#=====================================================================
# SQL-Ledger Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#======================================================================
#
# Accounts Payables
#
#======================================================================


use SL::AP;
use SL::IR;

1;
# end of main


# this is for our long dates
# $locale->text('January')
# $locale->text('February')
# $locale->text('March')
# $locale->text('April')
# $locale->text('May ')
# $locale->text('June')
# $locale->text('July')
# $locale->text('August')
# $locale->text('September')
# $locale->text('October')
# $locale->text('November')
# $locale->text('December')

# this is for our short month
# $locale->text('Jan')
# $locale->text('Feb')
# $locale->text('Mar')
# $locale->text('Apr')
# $locale->text('May')
# $locale->text('Jun')
# $locale->text('Jul')
# $locale->text('Aug')
# $locale->text('Sep')
# $locale->text('Oct')
# $locale->text('Nov')
# $locale->text('Dec')


sub add {

  $form->{title} = "Add";
  $form->{callback} = "$form->{script}?action=add&path=$form->{path}&login=$form->{login}&password=$form->{password}";

if($form->{transdate}){
 $lastbatch = $form->{batch};
 $lastdate = $form->{transdate};
 }

  &create_links;
if($lastdate){
 $form->{transdate}=$lastdate;
$form->{batch}=$lastbatch;
}
  # lock the exchangerate field
  $form->{forex} = 1;
  $form->{"forex_1"} = 1;
  
  &display_form;
  
}


sub edit {
  
  $form->{title} = "Edit";

  &create_links;
  &display_form;

}


sub display_form {
  
  &form_header;
  &form_footer;

}


sub create_links {
  
  $form->create_links("AP", \%myconfig, "vendor");

  $taxincluded = $form->{taxincluded};
  
  # build the popup menus

  # currencies
  @curr = split /:/, $form->{currencies};
  chomp $curr[0];
  $form->{defaultcurrency} = $curr[0];

  map { $form->{selectcurrency} .= "<option>$_\n" } @curr;
  
  # vendors
  foreach $ref (@{ $form->{all_vendor} }) {
    if ($ref->{id} == $form->{vendor_id}) {
      $form->{vendor} = "$ref->{name}--$ref->{id}";
      $duedate = $form->{duedate};         # save duedate, we are using IR
      IR->get_vendor(\%myconfig, \%$form);
      $form->{duedate} = $duedate;           # work-around
    }
    $form->{selectvendor} .= "<option>$ref->{name}--$ref->{id}\n";
  }

  # forex
  $form->{forex} = $form->{exchangerate};
  
  foreach $key (keys %{ $form->{AP_links} }) {
    
    foreach $ref (@{ $form->{AP_links}{$key} }) {
      if ($key eq "AP_tax") {
	$form->{"selectAP_tax_$ref->{accno}"} = "<option>$ref->{accno}--$ref->{description}\n";
	next;
      }
      $form->{"select$key"} .= "<option>$ref->{accno}--$ref->{description}\n";
    }
	
    # if there is a value we have an old entry
    # $i is only used for paid
    for $i (1 .. scalar @{ $form->{acc_trans}{$key} }) {

      if ($key eq "AP_paid") {
	$form->{"AP_paid_$i"} = "$form->{acc_trans}{$key}->[$i-1]->{accno}--$form->{acc_trans}{$key}->[$i-1]->{description}";
	$form->{"paid_$i"} = $form->{acc_trans}{$key}->[$i-1]->{amount};
	$form->{"datepaid_$i"} = $form->{acc_trans}{$key}->[$i-1]->{transdate};
	$form->{"source_$i"} = $form->{acc_trans}{$key}->[$i-1]->{source};
	
	if ($form->{"exchangerate_$i"} = $form->{acc_trans}{$key}->[$i-1]->{exchangerate}) {
	  $form->{"forex_$i"} = 1;
	} else {
	  $form->{"exchangerate_$i"} = 1;
	}
	
	$form->{paidaccounts}++;
      } else {

        $akey = $key;
        $akey =~ s/AP_//;

	if ($key eq "AP_tax") {
	  $form->{"${key}_$form->{acc_trans}{$key}->[$i-1]->{accno}"} = "$form->{acc_trans}{$key}->[$i-1]->{accno}--$form->{acc_trans}{$key}->[$i-1]->{description}";
	  $form->{"${akey}_$form->{acc_trans}{$key}->[$i-1]->{accno}"} = $form->round_amount($form->{acc_trans}{$key}->[$i-1]->{amount} / $form->{exchangerate} * -1, 2);
	  $totaltax += $form->{"${akey}_$form->{acc_trans}{$key}->[$i-1]->{accno}"};
	} else {
	  $form->{$akey} = $form->round_amount($form->{acc_trans}{$key}->[0]->{amount} / $form->{exchangerate}, 2);
	  $form->{$key} = "$form->{acc_trans}{$key}->[0]->{accno}--$form->{acc_trans}{$key}->[0]->{description}";
	}
      }
    }
  }

  $form->{taxincluded} = $taxincluded if ($form->{id});
  $form->{paidaccounts} = 1 if not defined $form->{paidaccounts};

  $form->{amount} *= -1;
  $form->{invtotal} = $form->{amount} + $totaltax;

  if ($form->{taxincluded}) {
    $form->{amount} += $totaltax;
  }

  $form->{locked} = ($form->datetonum($form->{transdate}, \%myconfig) <= $form->datetonum($form->{closedto}, \%myconfig));
  
}


sub form_header {

  $title = $form->{title};
  $form->{title} = $locale->text("$title Accounts Payables");

  $form->{taxincluded} = ($form->{taxincluded}) ? "checked" : "";
  
# type=submit $locale->text('Add Accounts Payables')
# type=submit $locale->text('Edit Accounts Payables')

  # set option selected
  map { $form->{"select$_"} =~ s/ selected// } qw(AP AP_amount vendor currency);
  map { $form->{"select${_}"} =~ s/option>\Q$form->{$_}\E/option selected>$form->{$_}/ } qw(AP AP_amount vendor currency);

  
  # format amounts
  $form->{amount} = $form->format_amount(\%myconfig, $form->{amount}, 2);
  $form->{exchangerate} = $form->format_amount(\%myconfig, $form->{exchangerate});

  $exchangerate = qq|&nbsp;|;
  if ($form->{currency} ne $form->{defaultcurrency}) {
    if ($form->{forex}) {
      $exchangerate = qq|<input type=hidden name=exchangerate value=$form->{exchangerate}>$form->{exchangerate}|;
    } else {
      $exchangerate = qq|<input name=exchangerate size=10 value=$form->{exchangerate}>|;
    }
  }
  $exchangerate .= qq|
<input type=hidden name=forex value=$form->{forex}>
|;


  if (($rows = $form->numtextrows($form->{notes}, 50)) < 2) {
    $rows = 2;
  }
  $notes = qq|<textarea name=notes rows=$rows cols=50 wrap=soft>$form->{notes}</textarea>|;
  
  
  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>

<input type=hidden name=id value=$form->{id}>
<input type=hidden name=sort value=$form->{sort}>
<input type=hidden name=closedto value=$form->{closedto}>
<input type=hidden name=locked value=$form->{locked}>
<input type=hidden name=title value="$title">

<table border=1>
<tr class=listtop bgcolor=000000><th>
<font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>

<table>

<tr>

  <th align=right>|.$locale->text('Record in').qq|</th>
  <td colspan=3><select name=AP>$form->{selectAP}</select><input name="accno1" size=10 value=$form->{"accno1"}></td>

  <input type=hidden name=selectAP value="$form->{selectAP}">
</tr>

<tr>

  <th align=right>|.$locale->text('Vendor').qq|</th>
  <td colspan=3><select name=vendor>$form->{selectvendor}</select><input name="cust1" size=10 value=$form->{"cust1"}></td>

  <input type=hidden name=selectvendor value="$form->{selectvendor}">
  <input type=hidden name=oldvendor value="$form->{vendor_id}">
  <input type=hidden name=terms value=$form->{terms}>
</tr>
|;

  if ($form->{taxaccounts}) {
    print qq|
<tr>

  <th align=right>|.$locale->text('Tax Included').qq|</th>
  <td colspan=3><input name=taxincluded class=checkbox type=checkbox value=1 $form->{taxincluded}></td>

</tr>|;
  }

  print qq|
<tr>

  <th align=right>|.$locale->text('Invoice Number').qq|</th>
  <td><input name=invnumber size=20 value="$form->{invnumber}"></td>
  <th align=right>|.$locale->text('Order Number').qq|</th>
  <td><input name=ordnumber size=20 value="$form->{ordnumber}"></td>

</tr>

<tr>

  <th align=right>|.$locale->text('Invoice Date').qq|<br>($myconfig{'dateformat'})</th>
  <td><input name=transdate size=11 value=$form->{transdate}></td>
  <th align=right>|.$locale->text('Due Date').qq|<br>($myconfig{'dateformat'})</th>
  <td><input name=duedate size=11 value=$form->{duedate}></td>

</tr>

<tr>

  <th align=right>|.$locale->text('Currency').qq|</th>
  <td><select name=currency>$form->{selectcurrency}</select></td>
  <th align=right>|.$locale->text('Exchangerate').qq|</th>
  <td>$exchangerate</td>

  <input type=hidden name=selectcurrency value="$form->{selectcurrency}">
  <input type=hidden name=defaultcurrency value=$form->{defaultcurrency}>
  <input type=hidden name=fxgain_accno value=$form->{fxgain_accno}>
  <input type=hidden name=fxloss_accno value=$form->{fxloss_accno}>
</tr>

<tr>

  <th align=right>|.$locale->text('Amount').qq|</th>
  <td><input name=amount size=10 value=$form->{amount}></td>
  <td colspan=2><select name=AP_amount>$form->{selectAP_amount}</select></td>

  <input type=hidden name=selectAP_amount value="$form->{selectAP_amount}">
</tr>

<input type=hidden name=taxaccounts value="$form->{taxaccounts}">
|;


  $taxlabel = ($form->{taxincluded}) ? $locale->text('Tax Included') : $locale->text('Tax');
  
  foreach $item (split / /, $form->{taxaccounts}) {

    # format and reverse tax
    $form->{"tax_$item"} = $form->format_amount(\%myconfig, $form->{"tax_$item"}, 2); 

    print qq|
<tr>

  <th align=right>${taxlabel}</th>
  <td><input name="tax_$item" size=9 value=$form->{"tax_$item"}></td>
  <td colspan=2><select name=AP_tax_$item>$form->{"selectAP_tax_$item"}</select></td>

</tr>
 
<input type=hidden name="${item}_rate" value="$form->{"${item}_rate"}">
<input type=hidden name="${item}_description" value="$form->{"${item}_description"}">
<input type=hidden name="selectAP_tax_$item" value="$form->{"selectAP_tax_$item"}">
|;
  }
   
  $form->{invtotal} = $form->format_amount(\%myconfig, $form->{invtotal}, 2);

  print qq|
<tr>

  <th align=right>|.$locale->text('Total').qq|</th>
  <td colspan=3>$form->{invtotal}</td>

</tr>

<tr>

  <th align=right>|.$locale->text('Notes').qq|</th>
  <td colspan=3>$notes</td>

</tr>

<tr>
  <td colspan=4>
    <table width=100%>
    <tr class=listheading><th colspan=5><font color=ffffff>|.$locale->text('Payments').qq|</font></th></tr>
|;


  @column_index = qw(datepaid paid exchangerate AP_paid source);

  $column_data{datepaid} = "<th>".$locale->text('Date')."<br>($myconfig{dateformat})</th>";
  $column_data{paid} = "<th>".$locale->text('Amount')."</th>";
  $column_data{exchangerate} = "<th>".$locale->text('Exch')."</th>";
  $column_data{AP_paid} = "<th>".$locale->text('Account')."</th>";
  $column_data{source} = "<th>".$locale->text('Source')."</th>";

  print "<tr>";
  map { print "$column_data{$_}\n" } @column_index;
  print "</tr>";

  $form->{paidaccounts}++ if ($form->{"paid_$form->{paidaccounts}"});
  for $i (1 .. $form->{paidaccounts}) {
    print "<tr>\n";

    $form->{"selectAP_paid_$i"} = $form->{selectAP_paid};
    $form->{"selectAP_paid_$i"} =~ s/option>\Q$form->{"AP_paid_$i"}\E/option selected>$form->{"AP_paid_$i"}/;

    # format amounts
    $form->{"paid_$i"} = $form->format_amount(\%myconfig, $form->{"paid_$i"}, 2);
    $form->{"exchangerate_$i"} = $form->format_amount(\%myconfig, $form->{"exchangerate_$i"});
    
    $exchangerate = qq|&nbsp;|;
    if ($form->{currency} ne $form->{defaultcurrency}) {
      if ($form->{"forex_$i"}) {
	$exchangerate = qq|<input type=hidden name="exchangerate_$i" value=$form->{"exchangerate_$i"}>$form->{"exchangerate_$i"}|;
      } else {
	$exchangerate = qq|<input name="exchangerate_$i" size=10 value=$form->{"exchangerate_$i"}>|;
      }
    }

    $exchangerate .= qq|
<input type=hidden name="forex_$i" value=$form->{"forex_$i"}>
|;

    $column_data{"paid_$i"} = qq|<td><input name="paid_$i" size=10 value=$form->{"paid_$i"}></td>|;
    $column_data{"AP_paid_$i"} = qq|<td><select name="AP_paid_$i">$form->{"selectAP_paid_$i"}</select></td>|;
    $column_data{"exchangerate_$i"} = qq|<td>$exchangerate</td>|;
    $column_data{"datepaid_$i"} = qq|<td><input name="datepaid_$i" size=11 value=$form->{"datepaid_$i"}></td>|;
    $column_data{"source_$i"} = qq|<td><input name="source_$i" size=10 value=$form->{"source_$i"}></td>|;

    map { print qq|$column_data{"${_}_$i"}\n| } @column_index;

    print "</tr>\n";
  }

  print qq|
    <input type=hidden name=paidaccounts value=$form->{paidaccounts}>
    <input type=hidden name=selectAP_paid value="$form->{selectAP_paid}">
    
    </table>
  </td>

</tr>
</table>

</td>
</tr>

|;

}


sub form_footer {

  print qq|

<input name=callback type=hidden value="$form->{callback}">

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

</table>

<br>
|;

  $transdate = $form->datetonum($form->{transdate}, \%myconfig);
  $closedto = $form->datetonum($form->{closedto}, \%myconfig);
  

  print "</form>

</body>
</html>
";

}


sub update_form {

  # split vendor
  ($null, $form->{vendor_id}) = split /--/, $form->{vendor};

  # recalculate form
  if ($form->{oldvendor} != $form->{vendor_id}) {
    IR->get_vendor(\%myconfig, \%$form);
  }
  
  $form->{exchangerate} = $exchangerate if ($form->{forex} = ($exchangerate = $form->check_exchangerate(\%myconfig, $form->{currency}, $form->{transdate}, 'sell')));

  # recalculate due date
  $form->{duedate} = $form->current_date(\%myconfig, $form->{transdate}, $form->{terms});
  
  map { $form->{$_} = $form->parse_amount(\%myconfig, $form->{$_}) } qw(amount exchangerate);

  # recalculate taxes
  if ($form->{taxincluded}) {
    $taxrate = 0;

    map { $taxrate += $form->{"${_}_rate"} } split / /, $form->{taxaccounts};

    foreach $item (split / /, $form->{taxaccounts}) {
      $form->{"tax_$item"} = $form->round_amount($form->{amount} * (1 - 1 / (1 + $taxrate)) * $form->{"${item}_rate"} / $taxrate, 2);
      $form->{"selectAP_tax_$item"} = qq|<option>$item--$form->{"${item}_description"}|;
      $totaltax += $form->{"tax_$item"};
    }
  } else {
    foreach $item (split / /, $form->{taxaccounts}) {
      $form->{"tax_$item"} = $form->{amount} * $form->{"${item}_rate"};
      $form->{"selectAP_tax_$item"} = qq|<option>$item--$form->{"${item}_description"}|;
      $totaltax += $form->{"tax_$item"};
    }
  }

  $form->{invtotal} = ($form->{taxincluded}) ? $form->{amount} : $form->{amount} + $totaltax;
  
  for $i (1 .. $form->{paidaccounts}) {
    if ($form->{"paid_$i"}) {
      map { $form->{"${_}_$i"} = $form->parse_amount(\%myconfig, $form->{"${_}_$i"}) } qw(paid exchangerate);
      
      $form->{"exchangerate_$i"} = $exchangerate if ($form->{"forex_$i"} = ($exchangerate = $form->check_exchangerate(\%myconfig, $form->{currency}, $form->{"datepaid_$i"}, 'sell')));
    }
  }

   $form->create_links("AP", \%myconfig, "vendor");
  foreach $key (keys %{ $form->{AP_links} }) {
    $form->{"select$key"} ="";

    foreach $ref (@{ $form->{AP_links}{$key} }) {
      if ($key eq 'AP_tax') {
	$form->{"selectAP_tax_$ref->{accno}"} = "<option>$ref->{accno}--$ref->{description}\n";
	next;
      }
#      $form->{"select$key"} .= "<option>$ref->{accno}--$ref->{description}\n";

			if($form->{"accno1"} eq ''){
					$form->{"select$key"} .= "<option>$ref->{accno}--$ref->{description}\n";

			}else{
				if ($ref->{accno} =~ /^$form->{"accno1"}/){
					$form->{"select$key"} .= "<option>$ref->{accno}--$ref->{description}\n";
				}
			}

    }

    }

  &display_form;

}
 
 
sub post_transaction {

  # check if there is an invoice number, invoice and due date
  $form->isblank("invnumber", $locale->text("Invoice Number missing!"));
  $form->isblank("transdate", $locale->text("Invoice Date missing!"));
  $form->isblank("duedate", $locale->text("Due Date missing!"));
  
  $closedto = $form->datetonum($form->{closedto}, \%myconfig);
  $transdate = $form->datetonum($form->{transdate}, \%myconfig);

  $form->error($locale->text('Cannot post transaction for a closed period!')) if ($transdate <= $closedto);

  $form->isblank("exchangerate", $locale->text('Exchangerate missing!')) if ($form->{currency} ne $form->{defaultcurrency});

  for $i (1 .. $form->{paidaccounts}) {
    if ($form->{"paid_$i"}) {
      $datepaid = $form->datetonum($form->{"datepaid_$i"}, \%myconfig);

      $form->isblank("datepaid_$i", $locale->text('Payment date missing!'));

      $form->error($locale->text('Cannot post payment for a closed period!')) if ($datepaid <= $closedto);

      if ($form->{currency} ne $form->{defaultcurrency}) {
	$form->{"exchangerate_$i"} = $form->{exchangerate} if ($transdate == $datepaid);
	$form->isblank("exchangerate_$i", $locale->text('Exchangerate for payment missing!'));
      }
      
    }
  }
      
 
  # split vendor
  ($null, $form->{vendor_id}) = split /--/, $form->{vendor};
  
  # if the vendor changed get new vendor
  if ($form->{oldvendor} != $form->{vendor_id}) {
    IR->get_vendor(\%myconfig, \%$form);
  }

  $form->isposted(AP->post_transaction(\%myconfig, \%$form));
  
}


sub post_as_new_transaction {

  $form->{id} = 0;
  &post_transaction;

}


sub delete_transaction {

  $form->{title} = $locale->text('Confirm!');
  
  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>
|;

  foreach $key (keys %$form) {
    print qq|<input type=hidden name=$key value="$form->{$key}">\n|;
  }

  print qq|
<h2><font color=blue>$form->{title}</font></h2>

<b>|.$locale->text('Are you sure you want to delete Transaction').qq| $form->{invnumber}</b>
<p>

<input name=action class=submit type=submit value="|.$locale->text('Yes Delete Transaction').qq|">
</form>

</body>
</html>
|;

}



sub yes_delete_transaction {

  $form->isdeleted(AP->delete_transaction(\%myconfig, \%$form));

}


sub search {
  
  # setup vendor selection
  $form->all_vc(\%myconfig, "vendor");
  
  my $selection = "<option selected>" . $locale->text('All Vendors') ."\n";
  
  foreach $ref (@{ $form->{all_vendor} }) {
    $selection .= "<option>$ref->{name}--$ref->{id}\n";
  }
 
  if ($form->{nextsub} eq "payments") {
    $form->{title} = $locale->text('Process Payments');
    $listopen = qq|
    <input type=hidden name=sort value=invnumber>
    <input type=hidden name=open value=Y>|;
  }
  if ($form->{nextsub} eq "ap_transactions") {
    $form->{title} = $locale->text('AP Transactions');
    $listopen = qq|
<input type=hidden name=sort value=transdate>

<tr>

  <th align=right>|.$locale->text('Include in Report').qq|</th>
  <td colspan=3>
  <input name=open class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Open').qq|
  <input name=closed class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Closed').qq|

  <br>
      
  <input name="l_id" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('ID').qq| 
  <input name="l_invnumber" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Invoice Number').qq| 
  <input name="l_ordnumber" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Order Number').qq|
  <input name="l_name" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Vendor').qq|<br>
  <input name="l_transdate" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Invoice Date').qq|
  <input name="l_netamount" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Amount').qq|
  <input name="l_tax" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Tax').qq|
  <input name="l_amount" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Total').qq|<br>
  <input name="l_datepaid" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Date Paid').qq|
  <input name="l_paid" class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Paid').qq|
  <input name="l_duedate" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Due Date').qq|
  <input name="l_due" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Due').qq|
  <input name="l_notes" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Notes').qq|<br>
  <input name="l_subtotal" class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Subtotal').qq|

  </td>

</tr>
|;
  }
    
  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>

<table border=1>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr><td>

<table>

<tr>

<th align=right>|.$locale->text('Vendor').qq|</th>
<td colspan=3><select name=vendor>$selection</select></td>

</tr>

<tr>

<th align=right>|.$locale->text('Invoice Number').qq|</th>
<td colspan=3><input name=invnumber size=20></td>

</tr>

<tr>

<th align=right>|.$locale->text('Order Number').qq|</th>
<td colspan=3><input name=ordnumber size=20></td>

</tr>

<tr>

<th align=right>|.$locale->text('Notes').qq|</th>
<td colspan=3><input name=notes size=50></td>

</tr>

<tr>

<th align=right>|.$locale->text('From').qq|<br>($myconfig{dateformat})</th>
<td><input name=transdatefrom size=11></td>
<th align=right>|.$locale->text('To').qq|</th>
<td><input name=transdateto size=11></td>

</tr>

$listopen

</table>

</td></tr>
</table>

<p>
<input type=hidden name=nextsub value=$form->{nextsub}>
<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<input class=submit type=submit name=action value="|.$locale->text('Continue').qq|">
</form>

<p>|.$locale->text('To display all transactions, leave fields blank')

.qq|

</body>
</html>
|;

}


sub continue {
  
  &{ $form->{nextsub} };

}


sub ap_transactions {
    
 
  # split vendor
  ($vendor, $form->{vendor_id}) = split(/--/, $form->{vendor});

  # $form->{vendor_id} is needed in AP->ap_transactions
  AP->ap_transactions(\%myconfig, \%$form);

  # construct href
  $href = "$form->{script}?action=ap_transactions&path=$form->{path}&login=$form->{login}&password=$form->{password}&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&closed=$form->{closed}&invnumber=".$form->escape($form->{invnumber})."&ordnumber=".$form->escape($form->{ordnumber})."&notes=".$form->escape($form->{notes})."&vendor=".$form->escape($form->{vendor});

  # construct callback
  $vendor = $form->{vendor};
  $vendor =~ s/&/_/g;
  $callback = "$form->{script}?action=ap_transactions&path=$form->{path}&login=$form->{login}&password=$form->{password}&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&closed=$form->{closed}&invnumber=$form->{invnumber}&ordnumber=$form->{ordnumber}&notes=$form->{notes}&vendor=$vendor";

  @columns = $form->sort_columns(qw(transdate id invnumber ordnumber name netamount tax amount paid datepaid due duedate notes));

  foreach $item (@columns) {
    if ($form->{"l_$item"} eq "Y") {
      push @column_index, $item;
      
      # add column to href and callback
      $callback .= "&l_$item=Y";
      $href .= "&l_$item=Y";
    }
  }
  
  if ($form->{l_subtotal} eq 'Y') {
    $callback .= "&l_subtotal=Y";
    $href .= "&l_subtotal=Y";
  }
  
    
  $column_header{id} = qq|<th><a class=listheading href=$href&sort=id><font color=ffffff>|.$locale->text('ID').qq|</font></a></th>|;
  $column_header{transdate} = qq|<th><a class=listheading href=$href&sort=transdate><font color=ffffff>|.$locale->text('Date').qq|</font></a></th>|;
  $column_header{duedate} = qq|<th><a class=listheading href=$href&sort=duedate><font color=ffffff>|.$locale->text('Due').qq|</font></a></th>|;
  $column_header{due} = qq|<th><font color=ffffff>|.$locale->text('Due').qq|</font></th>|;
  $column_header{invnumber} = qq|<th><a class=listheading href=$href&sort=invnumber><font color=ffffff>|.$locale->text('Invoice').qq|</font></a></th>|;
  $column_header{ordnumber} = qq|<th><a class=listheading href=$href&sort=ordnumber><font color=ffffff>|.$locale->text('Order').qq|</font></a></th>|;
  $column_header{name} = qq|<th><a class=listheading href=$href&sort=name><font color=ffffff>|.$locale->text('Vendor').qq|</font></a></th>|;
  $column_header{netamount} = qq|<th><font color=ffffff>|.$locale->text('Amount').qq|</font></th>|;
  $column_header{tax} = qq|<th><font color=ffffff>|.$locale->text('Tax').qq|</font></th>|;
  $column_header{amount} = qq|<th><font color=ffffff>|.$locale->text('Total').qq|</font></th>|;
  $column_header{paid} = qq|<th><font color=ffffff>|.$locale->text('Paid').qq|</font></th>|;
  $column_header{datepaid} = qq|<th><a class=listheading href=$href&sort=datepaid><font color=ffffff>|.$locale->text('Date Paid').qq|</font></a></th>|;
  $column_header{notes} = qq|<th><a class=listheading><font color=ffffff>|.$locale->text('Notes').qq|</font></th>|;

  $form->{title} = $locale->text('AP Transactions');
  
  ($vendor) = split /--/, $form->{vendor};
  if ($form->{vendor_id}) {
    $option .= $vendor;
  }
  if ($form->{invnumber}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Invoice Number')." : $form->{invnumber}";
  }
  if ($form->{ordnumber}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Order Number')." : $form->{ordnumber}";
  }
  if ($form->{notes}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Notes')." : $form->{notes}";
  }
  if ($form->{transdatefrom}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('From')." ".$locale->date(\%myconfig, $form->{transdatefrom}, 1);
  }
  if ($form->{transdateto}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('To')." ".$locale->date(\%myconfig, $form->{transdateto}, 1);
  }
  if ($form->{open}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Open');
  }
  if ($form->{closed}) {
    $option .= "\n<br>" if ($option);
    $option .= $locale->text('Closed');
  }

  $colspan = $#column_index + 1;

  $form->header;
  
  print qq|
<body bgcolor=ffffff>

<table border=1>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr><td colspan=$colspan>$option</td></tr>

<tr class=listheading bgcolor=336666>|;

map { print "\n$column_header{$_}" } @column_index;

print qq|
</tr>
|;

  # add sort and escape callback
  $callback = $form->escape("$callback&sort=$form->{sort}");

  if (@{ $form->{AP} }) {
    $sameitem = $form->{AP}->[0]->{$form->{sort}};
  }
  
  # sums and tax on reports by Antonio Gallardo
  #
  foreach $ap (@{ $form->{AP} }) {

    if ($form->{l_subtotal} eq 'Y') {
      if ($sameitem ne $ap->{$form->{sort}}) {
	&ap_subtotal;
	$sameitem = $ap->{$form->{sort}};
      }
    }
    
    $column_data{netamount} = "<td align=right>".$form->format_amount(\%myconfig, $ap->{netamount}, 2, "&nbsp;")."</td>";
    $column_data{tax} = "<td align=right>".$form->format_amount(\%myconfig, $ap->{amount} - $ap->{netamount}, 2, "&nbsp;") . "</td>";
    $column_data{amount} = "<td align=right>".$form->format_amount(\%myconfig, $ap->{amount}, 2, "&nbsp;") . "</td>";
    $column_data{paid} = "<td align=right>".$form->format_amount(\%myconfig, $ap->{paid}, 2, "&nbsp;")."</td>";
    $column_data{due} = "<td align=right>".$form->format_amount(\%myconfig, $ap->{amount} - $ap->{paid}, 2, "&nbsp;")."</td>";

    $totalnetamount += $ap->{netamount};
    $totalamount += $ap->{amount};
    $totalpaid += $ap->{paid};
    $totaldue += ($ap->{amount} - $ap->{paid});

    $subtotalnetamount += $ap->{netamount};
    $subtotalamount += $ap->{amount};
    $subtotalpaid += $ap->{paid};
    $subtotaldue += ($ap->{amount} - $ap->{paid});

    $column_data{transdate} = "<td>$ap->{transdate}&nbsp;</td>";
    $column_data{duedate} = "<td>$ap->{duedate}&nbsp;</td>";
    $column_data{datepaid} = "<td>$ap->{datepaid}&nbsp;</td>";

    $module = ($ap->{invoice}) ? "ir.pl" : $form->{script};

    $column_data{invnumber} = qq|<td><a href="$module?action=edit&path=$form->{path}&id=$ap->{id}&login=$form->{login}&password=$form->{password}&callback=$callback">$ap->{invnumber}</a></td>|;
    $column_data{id} = "<td>$ap->{id}</td>";
    $column_data{ordnumber} = "<td>$ap->{ordnumber}&nbsp;</td>";
    $column_data{name} = "<td>$ap->{name}</td>";
    $ap->{notes} =~ s/^M/<br>/g;
    $column_data{notes} = "<td>$ap->{notes}&nbsp;</td>";
    
    $i++;
    $i %= 2;
    print "<tr class=listrow$i >";
    
    map { print "\n$column_data{$_}" } @column_index;

    print qq|
    </tr>
|;

  }
  
  if ($form->{l_subtotal} eq 'Y') {
    &ap_subtotal;
  }
  
  # print totals
  print qq|<tr class=listtotal bgcolor=000000>|;
  
  map { $column_data{$_} = "<td>&nbsp;</td>" } @column_index;
  
  $column_data{netamount} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $totalnetamount, 2, "&nbsp;")."</font></th>";
  $column_data{tax} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $totalamount - $totalnetamount, 2, "&nbsp;")."</font></th>";
  $column_data{amount} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $totalamount, 2, "&nbsp;")."</font></th>";
  $column_data{paid} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $totalpaid, 2, "&nbsp;")."</font></th>";
  $column_data{due} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $totaldue, 2, "&nbsp;")."</font></th>";

  map { print "$column_data{$_}\n" } @column_index;

  print qq|</tr>
  
</table>

<p>|.$locale->text('Click on table headers to sort table').qq|
<br>|.$locale->text('Click on invoice number to edit transaction')

.qq|

</body>
</html>
|;

}


sub ap_subtotal {

  map { $column_data{$_} = "<td>&nbsp;</td>" } @column_index;
  
  $column_data{netamount} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $subtotalnetamount, 2, "&nbsp;")."</font></th>";
  $column_data{tax} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $subtotalamount - $subtotalnetamount, 2, "&nbsp;")."</font></th>";
  $column_data{amount} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $subtotalamount, 2, "&nbsp;")."</font></th>";
  $column_data{paid} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $subtotalpaid, 2, "&nbsp;")."</font></th>";
  $column_data{due} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $subtotaldue, 2, "&nbsp;")."</font></th>";

  $subtotalnetamount = 0;
  $subtotalamount = 0;
  $subtotalpaid = 0;
  $subtotaldue = 0;

  print "<tr class=listsubtotal bgcolor=333366>";
  
  map { print "\n$column_data{$_}" } @column_index;

  print qq|
  </tr>
|;

}


sub payments {

  # split vendor
  ($vendor, $form->{vendor_id}) = split(/--/, $form->{vendor});
  
  AP->payments(\%myconfig, \%$form);

  # construct href
  $href = "$form->{script}?action=payments&path=$form->{path}&login=$form->{login}&password=$form->{password}&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&invnumber=" . $form->escape($form->{invnumber}) . "&ordnumber=" . $form->escape($form->{ordnumber}) . "&vendor=" . $form->escape($form->{vendor});


  @column_index = $form->sort_columns(qw(invnumber transdate ordnumber name amount currency exchangerate source));

  $column_header{transdate} = qq|<th><a class=listheading href=$href&sort=transdate><font color=ffffff>|.$locale->text('Date').qq|</font></a></th>|;
  $column_header{invnumber} = qq|<th><a class=listheading href=$href&sort=invnumber><font color=ffffff>|.$locale->text('Invoice').qq|</font></a></th>|;
  $column_header{ordnumber} = qq|<th><a class=listheading href=$href&sort=ordnumber><font color=ffffff>|.$locale->text('Order').qq|</font></a></th>|;
  $column_header{name} = qq|<th><a class=listheading href=$href&sort=name><font color=ffffff>|.$locale->text('Vendor').qq|</font></a></th>|;
  $column_header{amount} = qq|<th><font color=ffffff>|.$locale->text('Amount').qq|</font></th>|;
  $column_header{source} = "<th><font color=ffffff>".$locale->text('Source')."</font></th>";
  $column_header{currency} = "<th><font color=ffffff>".$locale->text('Curr')."</font></th>";
  $column_header{exchangerate} = "<th><font color=ffffff>".$locale->text('Exchangerate')."</font></th>";
  

  $form->{title} = $locale->text('Process Payments');
  $colspan = $#column_index + 1;

  $form->header;
    
  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>

<input type=hidden name=defaultcurrency value=$form->{defaultcurrency}>
<input type=hidden name=fxgain_accno value=$form->{fxgain_accno}>
<input type=hidden name=fxloss_accno value=$form->{fxloss_accno}>

<input type=hidden name=closedto value=$form->{closedto}>

<table border=0>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr class=listheading bgcolor=336666>|;

map { print "\n$column_header{$_}" } @column_index;

  print qq|
</tr>
|;

  # construct and escape callback
  $vendor = $form->{vendor};
  $vendor =~ s/&/_/g;
  $callback = $form->escape("$form->{script}?action=payments&path=$form->{path}&login=$form->{login}&password=$form->{password}&transdatefrom=$form->{transdatefrom}&transdateto=$form->{transdateto}&open=$form->{open}&sort=$form->{sort}&vendor=$vendor&invnumber=$form->{invnumber}&ordnumber=$form->{ordnumber}");
  

  # build the popup menu for the accounts
  foreach $key (sort keys %{$form->{paidaccount}}) {
    $paidaccounts .= qq|<option>$form->{paidaccount}{$key}{accno}--$form->{paidaccount}{$key}{description}\n|;
  }

  foreach $ap (@{ $form->{AP} }) {
    $i++;

    $j++; $j %= 2;
    print "<tr class=listrow$j>";
    
    $column_data{transdate} = qq|<td><input type=hidden name="transdate_$i" value=$ap->{transdate}>$ap->{transdate}</td>|;

    $module = ($ap->{invoice}) ? "ir.pl" : $form->{script};
    $column_data{invnumber} = "<td><a href=$module?action=edit&id=$ap->{id}&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>$ap->{invnumber}</a></td>";

    $amount = $form->format_amount(\%myconfig, $ap->{amount} / $ap->{exchangerate}, 2, "&nbsp;");

    $column_data{ordnumber} = "<td>$ap->{ordnumber}&nbsp;</td>";
    $column_data{name} = "<td>$ap->{name}</td>";
    $column_data{amount} = "<td align=right>$amount</td>";
    $column_data{currency} = "<td>$ap->{currency}&nbsp;</td>";
    $column_data{exchangerate} = ($ap->{currency} eq $form->{defaultcurrency}) ? "<td>&nbsp;</td>" : "<td>$ap->{exchangerate}</td>";
    $column_data{source} = "<td>&nbsp;</td>";
    
    map { print "$column_data{$_}\n" } @column_index;

    print qq|
</tr>
<tr>
|;
  
    
    # list all the payments
    $totalpaid = 0;
    $column_data{invnumber} = qq|<th>|.$locale->text('Payments').qq|</th>|;
    $column_data{ordnumber} = qq|<td>&nbsp;</td>|;
    
    foreach $ref (@{ $ap->{payments} }) {
      $j++; $j %= 2;

      print "<tr class=listrow$j>";

      $column_data{transdate} = qq|<td>$ref->{transdate}</td>|;
      $column_data{name} = qq|<td>$form->{paidaccount}{$ref->{accno}}{description}</td>|;
      $column_data{amount} = qq|<td align=right>|.$form->format_amount(\%myconfig, $ref->{amount}, 2, "&nbsp;").qq|</td>|;
      $column_data{currency} = qq|<td>$ap->{currency}</td>|;
      $column_data{exchangerate} = ($ap->{currency} eq $form->{defaultcurrency}) ? "<td>&nbsp;</td>" : "<td>$ref->{exchangerate}</td>";
      $column_data{source} = qq|<td>$ref->{source}&nbsp;</td>|;
      
      map { print "\n$column_data{$_}" } @column_index;

      print qq|</tr>\n|;

      $column_data{invnumber} = qq|<td>&nbsp;</td>|;

      $totalpaid += $ref->{amount};
    }
    
    print "</tr><tr>\n";

# arrange data for payment input
    $column_data{transdate} = qq|<td><input name="datepaid_$i" size=11></td>|;

    $column_data{name} = qq|<td><select name="accno_$i">$paidaccounts</select></td>|;

    $column_data{amount} = qq|<td align=right><input name="paid_$i" size=9></td>|;

    $column_data{source} = qq|<td><input name="source_$i" size=10></td>|;

    $column_data{exchangerate} = ($ap->{currency} eq $form->{defaultcurrency}) ? qq|<td>&nbsp;</td>| : qq|<td><input name="exchangerate_$i" size=10></td>|;

    map { print "\n$column_data{$_}" } @column_index;

    print qq|
</tr>

<input type=hidden name="currency_$i" value=$ap->{currency}>
<input type=hidden name="iexch_$i" value=$ap->{exchangerate}>
<input type=hidden name="totalpaid_$i" value=$totalpaid>
<input type=hidden name="id_$i" value=$ap->{id}>
<input type=hidden name="AP_$i" value=$ap->{AP_account}>

<tr><td colspan=7><hr size=3 noshade></td></tr>
|;

  }
  
  print qq|
</table>

<input type=hidden name=rowcount value=$i>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<p>
<input class=submit type=submit name=action value="|.$locale->text('Process Payments').qq|">

</form>

<p>|.$locale->text('Click on table headers to sort table').qq|
<br>|.$locale->text('Click on invoice number to edit transaction')

.qq|

</body>
</html>
|;

}


sub process_payments {

  $closedto = $form->datetonum($form->{closedto}, \%myconfig);

  $msg = $locale->text('Cannot post transaction for a closed period!');
   
  # check closedto
  for $i (1 .. $form->{rowcount}) {
    if ($form->{"datepaid_$i"}) {
      $datepaid = $form->datetonum($form->{"datepaid_$i"}, \%myconfig);
      $form->error($msg) if ($datepaid <= $closedto);
    }
  }


  # construct callback
  $form->{callback} = "$form->{script}?action=search&nextsub=payments&path=$form->{path}&login=$form->{login}&password=$form->{password}";

  AP->process_payments(\%myconfig, \%$form);
  $form->redirect;
 
}



