#=====================================================================
# SQL-Ledger, Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#======================================================================
#
# Inventory Control module
#
#======================================================================


use SL::IC;

require "$form->{path}/io.pl";

1;
# end of main



sub add {

  $form->{title} = $locale->text('Add ' . ucfirst $form->{item});

  $form->{callback} = "$form->{script}?action=add&item=$form->{item}&path=$form->{path}&login=$form->{login}&password=$form->{password}";

  $form->{unit} = ($form->{item} eq 'service') ? $locale->text('hr') : $locale->text('ea');

  &link_part;
  
  &display_form;
  
}


sub search {

  $form->{title} = $locale->text('Reports');
  
  $form->header;
  
  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>

<table border=1>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>
<table>

<tr>

  <th align=right>|.$locale->text('Number').qq|</th>
  <td colspan=3><input name=partnumber size=20></td>

</tr>

<tr>

  <th align=right>|.$locale->text('Description').qq|</th>
  <td colspan=3><input name=description size=35></td>

</tr>

<tr>

  <th align=right>|.$locale->text('Make').qq|</th>
  <td><input name=make size=20></td>
  
  <th align=right>|.$locale->text('Model').qq|</th>
  <td><input name=model size=20></td>

</tr>


<tr>
  <td colspan=4>
    <input name=searchitems class=radio type=radio value=all checked>&nbsp;|.$locale->text('All').qq|
    <input name=searchitems class=radio type=radio value=parts>&nbsp;|.$locale->text('Parts').qq|
    <input name=searchitems class=radio type=radio value=assemblies>&nbsp;|.$locale->text('Assemblies').qq|
    <input name=searchitems class=radio type=radio value=services>&nbsp;|.$locale->text('Services').qq|
<!--
    <input name=searchitems class=radio type=radio value="bom">&nbsp;BOM
-->
  </td>
</tr>

<tr>
  <td colspan=4>
    <input name=onhand class=checkbox type=checkbox value=1>&nbsp;|.$locale->text('On Hand').qq|
    <input name=short class=checkbox type=checkbox value=1>&nbsp;|.$locale->text('Short').qq|
    <input name=obsolete class=checkbox type=checkbox value=1>&nbsp;|.$locale->text('Obsolete').qq|
    <input name=orphaned class=checkbox type=checkbox value=1>&nbsp;|.$locale->text('Orphaned').qq|
  </td>
</tr>

<tr>
  <td colspan=4>
    <input name=bought class=checkbox type=checkbox value=1>&nbsp;|.$locale->text('Bought').qq|
    <input name=sold class=checkbox type=checkbox value=1>&nbsp;|.$locale->text('Sold').qq|
    &nbsp;&nbsp;&nbsp;<b>|.$locale->text('From').qq| ($myconfig{dateformat}) </b>
    <input name=transdatefrom size=11>
    <b>&nbsp;|.$locale->text('To').qq|</b>
    <input name=transdateto size=11>
  </td>
</tr>

<tr>
  <th align=right>|.$locale->text('Include in Report').qq|</th>
  <td colspan=3>
    <input name=l_partnumber class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Number').qq|
    <input name=l_description class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Description').qq|
    <input name=l_bin class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Bin').qq|
    <input name=l_onhand class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Qty').qq|
    <input name=l_rop class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('ROP').qq|<br>
    <input name=l_unit class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Unit of measure').qq|
    <input name=l_listprice class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('List Price').qq|
    <input name=l_sellprice class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Sell Price').qq|
    <input name=l_lastcost class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Last Cost').qq|<br>
    <input name=l_priceupdate class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Price Updated').qq|
    <input name=l_weight class=checkbox type=checkbox value=Y>&nbsp;|.$locale->text('Weight').qq|
    <input name=l_linetotal class=checkbox type=checkbox value=Y checked>&nbsp;|.$locale->text('Line Total').qq|
  </td>
</tr>

</table>
</td>

</tr>
</table>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<br>
<input class=submit type=submit name=action value="|.$locale->text('Generate Report').qq|">
</form>

<p>
|.$locale->text('To display all items, leave fields blank')

.qq|

</body>
</html>
|;

}


sub generate_report {

  # setup $form->{sort}
  unless ($form->{sort}) {
    if ($form->{description} && !($form->{partnumber})) {
      $form->{sort} = "description";
    } else {
      $form->{sort} = "partnumber";
    }
  }
  
  $callback = "$form->{script}?action=generate_report&path=$form->{path}&login=$form->{login}&password=$form->{password}&searchitems=$form->{searchitems}";

  IC->all_parts(\%myconfig, \%$form);

  if ($form->{searchitems} eq 'all') {
    $option = $locale->text('All')." : ";
  } else {
    $option = ucfirst $form->{searchitems};
    $option = $locale->text($option)." : ";
  }

  if ($form->{obsolete}) {
    $callback .= "&obsolete=$form->{obsolete}";
    $option .= $locale->text('Obsolete')." : ";
  }
  if ($form->{orphaned}) {
    $callback .= "&orphaned=$form->{orphaned}";
    $option .= $locale->text('Orphaned')." : ";
  }
  if ($form->{bought}) {
    $callback .= "&bought=$form->{bought}";
    $option .= $locale->text('Bought')." : ";
  }
  if ($form->{sold}) {
    $callback .= "&sold=$form->{sold}";
    $option .= $locale->text('Sold')." : ";
  }
  if ($form->{bought} || $form->{sold}) {
    if ($form->{transdatefrom}) {
      $callback .= "&transdatefrom=$form->{transdatefrom}";
      $option .= "\n<br>".$locale->text('From')."&nbsp;".$locale->date(\%myconfig, $form->{transdatefrom}, 1);
    }
    if ($form->{transdateto}) {
      $callback .= "&transdateto=$form->{transdateto}";
      $option .= "\n<br>".$locale->text('To')."&nbsp;".$locale->date(\%myconfig, $form->{transdateto}, 1);
    }
  }

  $option .= "<br>";
  
  if ($form->{partnumber}) {
    $callback .= "&partnumber=$form->{partnumber}";
    $option .= $locale->text('Number').qq| : $form->{partnumber}<br>|;
  }
  if ($form->{description}) {
    $callback .= "&description=$form->{description}";
    $option .= $locale->text('Description').qq| : $form->{description}<br>|;
  }
  if ($form->{make}) {
    $callback .= "&make=$form->{make}";
    $option .= $locale->text('Make').qq| : $form->{make}<br>|;
  }
  if ($form->{model}) {
    $callback .= "&model=$form->{model}";
    $option .= $locale->text('Model').qq| : $form->{model}<br>|;
  }

  if ($form->{searchitems} eq 'onhand' || $form->{searchitems} eq 'short') {
    # turn on onhand
    $form->{l_onhand} = "Y";
  }
  
  @columns = $form->sort_columns(qw(partnumber description bin onhand rop unit listprice sellprice linetotal lastcost priceupdate weight invnumber));

  if ($form->{searchitems} eq 'services') {
    # remove bin, weight and rop from list
    map { $form->{"l_$_"} = "" } qw(bin weight rop);

    # qty is irrelevant unless bought or sold
    unless ($form->{bought} || $form->{sold}) {
      $form->{l_onhand} = "";
      $form->{l_linetotal} = "";
    }
  }

  if ($form->{bought} || $form->{sold}) {
    # add invnumber
    $form->{l_invnumber} = "Y" unless ($form->{l_invnumber});
  }
  if ($form->{bought} && $form->{sold}) {
    $form->{boughtandsold} = 1;
    # change quantity field to Bought and Sold
    $form->{l_bought} = $form->{l_sold} = "Y";
    @columns = $form->sort_columns(qw(partnumber description bin bought sold rop unit listprice sellprice linetotal lastcost priceupdate weight invnumber));
  }

  $form->{l_lastcost} = "" if ($form->{searchitems} eq 'assemblies');
  
  foreach $item (@columns) {
    if ($form->{"l_$item"} eq "Y") {
      push @column_index, $item;

      # add column to callback
      $callback .= "&l_$item=Y";
    }
  }

  $column_header{partnumber} = qq|<th><a class=listheading href=$callback&sort=partnumber><font color=ffffff>|.$locale->text('Number').qq|</a></th>|;
  $column_header{description} = qq|<th><a class=listheading href=$callback&sort=description><font color=ffffff>|.$locale->text('Description').qq|</a></th>|;
  $column_header{bin} = qq|<th><a class=listheading href=$callback&sort=bin><font color=ffffff>|.$locale->text('Bin').qq|</a></th>|;
  $column_header{priceupdate} = qq|<th><a class=listheading href=$callback&sort=priceupdate><font color=ffffff>|.$locale->text('Price Updated').qq|</a></th>|;
  $column_header{onhand} = qq|<th><font color=ffffff>|.$locale->text('Qty').qq|</th>|;
  $column_header{bought} = qq|<th><font color=ffffff>|.$locale->text('Bought').qq|</th>|;
  $column_header{sold} = qq|<th><font color=ffffff>|.$locale->text('Sold').qq|</th>|;
  $column_header{unit} = qq|<th><font color=ffffff>|.$locale->text('Unit').qq|</th>|;
  $column_header{listprice} = qq|<th><font color=ffffff>|.$locale->text('List Price').qq|</th>|;
  $column_header{lastcost} = qq|<th><font color=ffffff>|.$locale->text('Last Cost').qq|</th>|;
  $column_header{rop} = qq|<th><font color=ffffff>|.$locale->text('ROP').qq|</th>|;
  $column_header{weight} = qq|<th><font color=ffffff>|.$locale->text('Weight').qq|</th>|;
  $column_header{invnumber} = qq|<th><a class=listheading href=$callback&sort=invnumber><font color=ffffff>|.$locale->text('Invoice Number').qq|</a></th>|;
  $column_header{sellprice} = qq|<th><font color=ffffff>|.$locale->text('Unit Price').qq|</th>|;
  $column_header{linetotal} = qq|<th><font color=ffffff>|.$locale->text('Total').qq|</th>|;
  
  $form->{title} = $locale->text('Inventory');
  
  $form->header;
  $colspan = $#column_index + 1;

  print qq|
<body bgcolor=ffffff>

<table border=1>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr><td colspan=$colspan>$option</td></tr>

  <tr class=listheading bgcolor=336666>
|;

  map { print "\n$column_header{$_}" } @column_index;
  
  print qq|
  </tr>
  |;


  # add order to callback and escape
  $callback = $form->escape($callback . "&sort=$form->{sort}");


  foreach $ref (@{ $form->{parts} }) {
    
    if ($ref->{onhand} < 0) {
      $column_data{onhand} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{onhand}, -1, "&nbsp;")."</td>";
      $column_data{bought} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{onhand} * -1, -1, "&nbsp;")."</td>";
      $column_data{sold} = "<td>&nbsp;</td>";

      if ($ref->{module} eq 'is') {
	$column_data{sold} = $column_data{onhand};
	$column_data{bought} = "<td>&nbsp;</td>";
      }
    } else {
      $column_data{sold} = $column_data{onhand} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{onhand}, -1, "&nbsp;")."</td>";
      $column_data{bought} = "<td>&nbsp;</td>";

      if ($ref->{module} eq 'ir') {
	$column_data{sold} = "<td>&nbsp;</td>";
	$column_data{bought} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{onhand} * -1, -1, "&nbsp;")."</td>";
      }
    }

    $ref->{onhand} *= -1 if $form->{boughtandsold};
    
    $column_data{sellprice} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{sellprice}, 2, "&nbsp;") . "</td>";
    $column_data{listprice} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{listprice}, 2, "&nbsp;") . "</td>";
    $column_data{lastcost} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{lastcost}, 2, "&nbsp;") . "</td>";
    $column_data{linetotal} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{onhand} * $ref->{sellprice}, 2, "&nbsp;")."</td>";
    $total += $ref->{onhand} * $ref->{sellprice};

    $column_data{rop} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{rop}, -1, "&nbsp;")."</td>";
    $column_data{weight} = "<td align=right>".$form->format_amount(\%myconfig, $ref->{weight}, -1, "&nbsp;")."</td>";
    $column_data{unit} = "<td>$ref->{unit}&nbsp;</td>";
    $column_data{bin} = "<td>$ref->{bin}&nbsp;</td>";
    $column_data{priceupdate} = "<td>$ref->{priceupdate}&nbsp;</td>";
    $column_data{partnumber} = "<td><a href=$form->{script}?action=edit&id=$ref->{id}&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>$ref->{partnumber}&nbsp;</a></td>";
    $column_data{description} = "<td>$ref->{description}</td>";
    $column_data{invnumber} = "<td><a href=$ref->{module}.pl?action=edit&type=invoice&id=$ref->{trans_id}&path=$form->{path}&login=$form->{login}&password=$form->{password}&callback=$callback>$ref->{invnumber}</a></td>";
    
    $i++; $i %= 2;
    print "<tr class=listrow$i>";

    map { print "\n$column_data{$_}" } @column_index;

    print qq|
    </tr>
|;

  }

  if ($form->{"l_linetotal"} && !$form->{boughtandsold}) {
    map { $column_data{$_} = "<td>&nbsp;</td>" } @column_index;
    $column_data{linetotal} = "<th align=right><font color=ffffff>".$form->format_amount(\%myconfig, $total, 2, "&nbsp;")."</font></th>";

    print "<tr class=listtotal bgcolor=000000>";

    map { print "\n$column_data{$_}" } @column_index;

    print qq|</tr>|;
  }

  print qq|
</table>

<p>|.$locale->text('Click on "Number" to edit')

.qq|

</body>
</html>
|;

}


sub edit {

  IC->get_part(\%myconfig, \%$form);

  $form->{title} = $locale->text('Edit '.ucfirst $form->{item});
  
  &link_part;

  &display_form;
  
}



sub link_part {

  IC->create_links("IC", \%myconfig, \%$form);

  # parts and assemblies have the same links
  $item = $form->{item};
  if ($form->{item} eq 'assembly') {
    $item = 'part';
  }
  
  # build the popup menus
  $form->{taxaccounts} = "";
  foreach $key (keys %{ $form->{IC_links} }) {
    foreach $ref (@{ $form->{IC_links}{$key} }) {
      # if this is a tax field
      if ($key =~ /IC_tax/) {
	if ($key =~ /$item/) {
	  $form->{taxaccounts} .= "$ref->{accno} ";
	  $form->{"IC_tax_$ref->{accno}_description"} = "$ref->{accno}--$ref->{description}";
	  
	  if ($form->{id}) {
	    if ($form->{amount}{$ref->{accno}}) {
	      $form->{"IC_tax_$ref->{accno}"} = "checked";
	    }
	  } else {
	    $form->{"IC_tax_$ref->{accno}"} = "checked";
	  }
	}
      } else {
	$form->{"select$key"} .= "<option>$ref->{accno}--$ref->{description}\n";
	if ($form->{amount}{$ref->{accno}}) {
	  $form->{$key} = "$ref->{accno}--$ref->{description}";
	}
	
      }
    }
  }
  chop $form->{taxaccounts};

  if (($form->{item} eq "part") || ($form->{item} eq "assembly")) {
    $form->{selectIC_income} = $form->{selectIC_sale};
    $form->{selectIC_expense} = $form->{selectIC_cogs};
    $form->{IC_income} = $form->{IC_sale};
    $form->{IC_expense} = $form->{IC_cogs};
  }
  
  delete $form->{IC_links};
  delete $form->{amount};

}


sub form_header {

  ($dec) = ($form->{sellprice} =~ /\.(\d+)/);
  $dec = length $dec;
  my $decimalplaces = ($dec > 2) ? $dec : 2;

  $form->{listprice} = $form->format_amount(\%myconfig, $form->{listprice}, $decimalplaces);
  $form->{sellprice} = $form->format_amount(\%myconfig, $form->{sellprice}, $decimalplaces);

  ($dec) = ($form->{lastcost} =~ /\.(\d+)/);
  $dec = length $dec;
  my $decimalplaces = ($dec > 2) ? $dec : 2;

  $form->{lastcost} = $form->format_amount(\%myconfig, $form->{lastcost}, $decimalplaces);

  foreach $item (qw(partnumber description unit notes)) {
    $form->{$item} =~ s/"/&quot;/g;
  }

  if (($rows = $form->numtextrows($form->{notes}, 40)) < 2) {
    $rows = 2;
  }
  $notes = qq|<textarea name=notes rows=$rows cols=40 wrap=soft>$form->{notes}</textarea>|;

  if (($rows = $form->numtextrows($form->{description}, 40)) > 1) {
    $description = qq|<textarea name="description" rows=$rows cols=40 wrap=soft>$form->{description}</textarea>|;
  } else {
    $description = qq|<input name=description size=40 value="$form->{description}">|;
  }
  
  foreach $item (split / /, $form->{taxaccounts}) {
    $form->{"IC_tax_$item"} = ($form->{"IC_tax_$item"}) ? "checked" : "";
  }

  # set option
  foreach $item (qw(IC IC_income IC_expense)) {
    $form->{"select$item"} =~ s/ selected//;
    $form->{"select$item"} =~ s/option>\Q$form->{$item}\E/option selected>$form->{$item}/;
  }

  # tax fields
  foreach $item (split / /, $form->{taxaccounts}) {
    $tax .= qq|<input class=checkbox type=checkbox name="IC_tax_$item" value=1 $form->{"IC_tax_$item"}>&nbsp;<b>$form->{"IC_tax_${item}_description"}</b>
               <br><input type=hidden name=IC_tax_${item}_description value=$form->{"IC_tax_${item}_description"}>
|;
  }

  $form->{obsolete} = ($form->{obsolete}) ? "checked" : "";
  

  if ($form->{item} eq "part") {

    $linkaccounts = qq|
<table>
  <tr>

  <th align=right>|.$locale->text('Inventory').qq|</th>
  <td><select name=IC>$form->{selectIC}</select></td>

<input name=selectIC type=hidden value="$form->{selectIC}">

  </tr>

  <tr>

  <th align=right>|.$locale->text('Sales').qq|</th>
  <td><select name=IC_income>$form->{selectIC_income}</select></td>

<input name=selectIC_income type=hidden value="$form->{selectIC_income}">

  </tr>

  <tr>

  <th align=right>|.$locale->text('COGS').qq|</th>
  <td><select name=IC_expense>$form->{selectIC_expense}</select></td>

<input name=selectIC_expense type=hidden value="$form->{selectIC_expense}">

  </tr>|;
  
  if ($tax) {
    $linkaccounts .= qq|<tr>
      <th align=right>|.$locale->text('Tax').qq|</th>
      <td>$tax</td>
      </tr>|;
  }

  $linkaccounts .= qq|
  </table>
|;


    $weight = qq|<tr>
	      <td>
                 <b>|.$locale->text('Weight').qq|</b>&nbsp;<input name=weight size=5 value=|.$form->format_amount(\%myconfig, $form->{weight}).qq|>&nbsp;<b>$form->{weightunit}</b></td>

	      <td>
                 <b>|.$locale->text('On Hand').qq|</b>&nbsp;->&nbsp;|.$form->format_amount(\%myconfig, $form->{onhand}).qq|</td>
  <input type=hidden name=weightunit value=$form->{weightunit}>
</tr>|;
    
    }


  if ($form->{item} eq "assembly") {
    
    $linkaccounts = qq|
<table>
  <tr>

  <th align=right>|.$locale->text('Sales').qq|</th>
  <td><select name=IC_income>$form->{selectIC_income}</select></td>

<input name=selectIC_income type=hidden value="$form->{selectIC_income}">

  </tr>|;
  
  if ($tax) {
    $linkaccounts .= qq|<tr>
      <th align=right>|.$locale->text('Tax').qq|</th>
      <td>$tax</td>
      </tr>|;
  }

  $linkaccounts .= qq|
  </table>
|;


    $weight = qq|<tr>
	      <td><b>|.$locale->text('Weight').qq|</b>&nbsp;|.$form->format_amount(\%myconfig, $form->{weight}).qq|&nbsp;<b>$form->{weightunit}</b></td>
		 
	      <td><b>|.$locale->text('On Hand').qq|</b>&nbsp;|.$form->format_amount(\%myconfig, $form->{onhand}).qq|</td>
	      </tr>
 
<input type=hidden name=weight value=$form->{weight}>
<input type=hidden name=weightunit value=$form->{weightunit}>
|;

  }

 
  if ($form->{item} eq "service") {
    
    $linkaccounts = qq|
<table>
  <tr>

  <th align=right>|.$locale->text('Income').qq|</th>
  <td><select name=IC_income>$form->{selectIC_income}</select></td>

<input name=selectIC_income type=hidden value="$form->{selectIC_income}">

  </tr>

  <tr>

  <th align=right>|.$locale->text('Expense').qq|</th>
  <td><select name=IC_expense>$form->{selectIC_expense}</select></td>

<input name=selectIC_expense type=hidden value="$form->{selectIC_expense}">

  </tr>|;
  
  if ($tax) {
    $linkaccounts .= qq|<tr>
      <th align=right>|.$locale->text('Tax').qq|</th>
      <td>$tax</td>
      </tr>|;
  }

  $linkaccounts .= qq|
  </table>
|;

  }


  unless ($form->{item} eq 'service') {
    $rop = qq|<b>|.$locale->text('ROP').qq|</b>&nbsp;<input name=rop size=5 value=|.$form->format_amount(\%myconfig, $form->{rop}).qq|>

    <br>
	  <b>|.$locale->text('Bin').qq|</b>&nbsp;<input name=bin size=10 value=$form->{bin}>|;
	  
  }

  if ($form->{id}) {
    $rop .= qq|<br>
	    <input name=obsolete type=checkbox class=checkbox value=1 $form->{obsolete}>&nbsp;<b>|.$locale->text('Obsolete').qq|</b>|;
  }

	
# type=submit $locale->text('Add Part')
# type=submit $locale->text('Add Service')
# type=submit $locale->text('Add Assembly')

# type=submit $locale->text('Edit Part')
# type=submit $locale->text('Edit Service')
# type=submit $locale->text('Edit Assembly')


  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>

<input name=id type=hidden value=$form->{id}>
<input name=item type=hidden value=$form->{item}>
<input name=title type=hidden value="$form->{title}">

<input name=makemodel type=hidden value="$form->{makemodel}">
<input name=alternate type=hidden value="$form->{alternate}">
<input name=onhand type=hidden value=$form->{onhand}>

<input name=taxaccounts type=hidden value="$form->{taxaccounts}">

<input name=rowcount type=hidden value=$form->{rowcount}>


<table border=1>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>
<table callspacing=0 cellpadding=0>

<tr valign=top>

  <td><b>|.$locale->text('Number').qq|</b>
  <br><input name=partnumber size=20 value="$form->{partnumber}"></td>
  <td><b>|.$locale->text('Description').qq|</b>
  <br>$description
  </td>

</tr>

$weight

<tr>

  <td>
         
	 <b>|.$locale->text('Unit of measure').qq|</b>&nbsp;<input name=unit size=5 maxsize=5 value="$form->{unit}">
	 
     </td>
     
  <td>
         
	 <b>|.$locale->text('Price Updated').qq|</b>&nbsp;<b>($myconfig{dateformat})</b>&nbsp;<input name=priceupdate size=11 value=$form->{priceupdate}>
	 
  </td>

</tr>

<tr>
  <td colspan=2>

      <b>|.$locale->text('List Price').qq|</b>&nbsp;<input name=listprice size=9 value=$form->{listprice}>&nbsp;<b>|.$locale->text('Sell Price').qq|</b>&nbsp;<input name=sellprice size=9 value=$form->{sellprice}>&nbsp;&nbsp;&nbsp;&nbsp;<b>|.$locale->text('Last Cost').qq|</b>&nbsp;->&nbsp;$form->{lastcost}</td>
    </tr>

<tr valign=top>

  <td>$rop</td>
  <td><b>|.$locale->text('Notes').qq|</b>
  <br>$notes
  </td>

</tr>

<tr>
  <td colspan=2>
  <table><tr>

  <th align=right>|.$locale->text('Link Accounts').qq|</th>
  <td>$linkaccounts</td>

  </table></td>
</tr>
|;


}


sub form_footer {

# type=submit $locale->text('Delete Part')
# type=submit $locale->text('Delete Service')
# type=submit $locale->text('Delete Assembly')
# type=submit $locale->text('Save Part')
# type=submit $locale->text('Save Service')
# type=submit $locale->text('Save Assembly')

  if ($form->{item} eq "assembly") {

    print qq|
<tr>
<th colspan=3 align=right>|.$locale->text('Total').qq|</th>
<th align=right>|.$form->format_amount(\%myconfig, $form->{assemblytotal}, 2).qq|</th></tr>

</table>
</td>
</tr>

  <input type=hidden name=assembly_rows value=$form->{assembly_rows}>
|;
  }

 
  print qq|

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<input type=hidden name=callback value="$form->{callback}">
<input type=hidden name=previous_form value="$form->{previous_form}">

</table>
</td>

</tr>
</table>

<br>

|;

  unless ($form->{item} eq "service") {
    print qq|
<input type=hidden name=makemodel_rows value=$form->{makemodel_rows}>
|;
  }




  print qq|
  </form>

</body>
</html>
|;

}


sub makemodel_row {
  my $i = shift;

  $form->{"make_$i"} =~ s/"/&quot;/g;
  $form->{"model_$i"} =~ s/"/&quot;/g;

  if ($i == 1) {
    print qq|
    <tr>
    <td><b>|.$locale->text('Make').qq|</b>
    <br><input name="make_$i" size=20 value="$form->{"make_$i"}"></td>
    <td><b>|.$locale->text('Model').qq|</b>
    <br><input name="model_$i" size=40 value="$form->{"model_$i"}"></td>

    </tr>
    |;
  } else {
    print qq|
    <tr>
    <td><input name="make_$i" size=20 value="$form->{"make_$i"}"></td>
    <td><input name="model_$i" size=40 value="$form->{"model_$i"}"></td>
    </tr>
    |;
  }
}


sub assembly_row {
  my $i = shift;

  $form->{"partnumber_$i"} =~ s/"/&quot;/g;

  @column_index = qw(qty partnumber description total);
  
  if ($i == 1) {

    if ($form->{previous_form}) {
      $nochange = 1;
    } else {
      # change callback
      $form->{old_callback} = $form->{callback};
      $callback = $form->{callback};
      $form->{callback} = "$form->{script}?action=display_form";

      # delete action
      delete $form->{action};

      $previous_form = "";
      # save form variables in a previous_form variable
      foreach $key (sort keys %$form) {
	# escape ampersands
	$form->{$key} =~ s/&/%26/g;
	$previous_form .= qq|$key=$form->{$key}&|;
      }
      chop $previous_form;
      $previous_form = $form->escape($form->escape($previous_form));
      $form->{callback} = $callback;
    }
    
    $form->{assemblytotal} = 0;
    $form->{weight} = 0;
    
    $column_header{qty} = qq|<th>|.$locale->text('Qty').qq|</th>|;
    $column_header{partnumber} = qq|<th>|.$locale->text('Number').qq|</th>|;
    $column_header{description} = qq|<th>|.$locale->text('Description').qq|</th>|;
    $column_header{total} = qq|<th>|.$locale->text('Amount').qq|</th>|;
    
    print qq|
<tr class=listheading bgcolor=336666><th colspan=2><font color=ffffff>|.$locale->text('Individual Items').qq|</font></th></tr>

<tr><td colspan=2>
<table>
  <tr>|;

  map { print "\n$column_header{$_}" } @column_index;
  
  print qq|
  </tr>
|;
  }

  $linetotal = $form->round_amount($form->{"sellprice_$i"} * $form->{"qty_$i"}, 2);
  $form->{assemblytotal} += $linetotal;
  
  $form->{"qty_$i"} = $form->format_amount(\%myconfig, $form->{"qty_$i"});

  $linetotal = $form->format_amount(\%myconfig, $linetotal, 2);

  if (($form->{assembly_rows} >= 1) && ($form->{assembly_rows} == $i)) {

    if ($nochange) {
      map { $column_data{$_} = qq|<td></td>| } qw(qty partnumber description);
    } else {
      
      $column_data{qty} = qq|<td><input name="qty_$i" size=5 value="$form->{"qty_$i"}"></td>|;
      $column_data{partnumber} = qq|<td><input name="partnumber_$i" size=15 value="$form->{"partnumber_$i"}"></td>|;
      $column_data{description} = qq|<td><input name="description_$i" size=30 value="$form->{"description_$i"}"></td>|;
    }

  } else {
    
    if ($form->{previous_form}) {
      $column_data{partnumber} = qq|<td><input type=hidden name="partnumber_$i" value="$form->{"partnumber_$i"}">$form->{"partnumber_$i"}</td>|;
      $column_data{qty} = qq|<td align=right><input type=hidden name="qty_$i" value="$form->{"qty_$i"}">$form->{"qty_$i"}</td>|;
    } else {
      $href = qq|$form->{script}?action=edit&id=$form->{"id_$i"}&path=$form->{path}&login=$form->{login}&password=$form->{password}&rowcount=$i&previous_form=$previous_form|;
      $column_data{partnumber} = qq|<td><input type=hidden name="partnumber_$i" value="$form->{"partnumber_$i"}"><a href=$href>$form->{"partnumber_$i"}</a></td>|;
      $column_data{qty} = qq|<td><input name="qty_$i" size=5 value="$form->{"qty_$i"}"></td>|;
    }

    $column_data{description} = qq|<td><input type=hidden name="description_$i" value="$form->{"description_$i"}">$form->{"description_$i"}</td>|;

  }
  
  $column_data{total} = qq|<td align=right>$linetotal</td>|;
  
  print qq|
<tr>|;

  map { print "\n$column_data{$_}" } @column_index;
  
  print qq|
</tr>
  <input type=hidden name="id_$i" value=$form->{"id_$i"}>
  <input type=hidden name="sellprice_$i" value=$form->{"sellprice_$i"}>
  <input type=hidden name="weight_$i" value=$form->{"weight_$i"}>
|;

 
}


sub update_form {

  if ($form->{item} eq "assembly") {

    $i = $form->{assembly_rows};
    
    # if last row is empty check the form otherwise retrieve item
    if (($form->{"partnumber_$i"} eq "") && ($form->{"description_$i"} eq "")) {
      
      &check_form;
      
    } else {

      IC->assembly_item(\%myconfig, \%$form);

      $rows = scalar @{ $form->{item_list} };
      
      if ($rows) {
	$form->{"qty_$i"} = 1 unless ($form->{"qty_$i"});
	
	if ($rows > 1) {
	  &select_item;
	  exit;
	} else {
	  map { $form->{item_list}[$i]{$_} =~ s/"/&quot;/g } qw(partnumber description);
	  map { $form->{"${_}_$i"} = $form->{item_list}[0]{$_} } keys %{ $form->{item_list}[0] };
	  $form->{assembly_rows}++;

	  &check_form;

	}

      } else {

        $form->{rowcount} = $i;
	$form->{assembly_rows}++;
	
	&new_item;

      }
    }
  }
  
  if ($form->{item} eq "part") {
    &check_form;
  }

  if ($form->{item} eq 'service') {
    map { $form->{$_} = $form->parse_amount(\%myconfig, $form->{$_}) } qw(sellprice listprice);
    
    &form_header;
    &form_footer;
  }

}


sub save_part {
  &save;
}

sub save_service {
  &save;
}

sub save_assembly {
  &save;
}


sub save {

  # check if there is a part number
  $form->isblank("partnumber", $locale->text(ucfirst $form->{item}." Number missing!"));

  if ($form->{obsolete}) {
    $form->error($locale->text("Inventory quantity must be zero before you can set this $form->{item} obsolete!")) if ($form->{onhand});
  }

# expand dynamic strings
# $locale->text('Inventory quantity must be zero before you can set this part obsolete!')
# $locale->text('Inventory quantity must be zero before you can set this assembly obsolete!')
# $locale->text('Part Number missing!')
# $locale->text('Service Number missing!')
# $locale->text('Assembly Number missing!')

  # save part
  $rc = IC->save(\%myconfig, \%$form);

  $parts_id = $form->{id};
  
  # load previous variables
  if ($form->{previous_form}) {
    # save the new form variables before splitting previous_form
    map { $newform{$_} = $form->{$_} } keys %$form;

    $previous_form = $form->unescape($form->{previous_form});
    $previous_form =~ s/%26/&/g;                  # moved up here for 2.0
    
    # don't trample on previous variables
    map { delete $form->{$_} } keys %newform;
  
    # now take it apart and restore original values
    foreach $item (split /&/, $previous_form) {
      $item = $form->unescape($item);             # added for Apache 2.0
      ($key, $value) = split /=/, $item, 2;
      $key = $form->unescape($key);               # added for Apache 2.0
      $value = $form->unescape($value);           # added for Apache 2.0
#      $value =~ s/%26/&/g;
      $form->{$key} = $value;
    }


    if ($form->{item} eq 'assembly') {

      # undo number formatting
      map { $form->{$_} = $form->parse_amount(\%myconfig, $form->{$_}) } qw(weight listprice sellprice rop);

      $form->{assembly_rows}--;
      $i = $newform{rowcount};
      $form->{"qty_$i"} = 1 unless ($form->{"qty_$i"});

      $form->{sellprice} -= $form->{"sellprice_$i"} * $form->{"qty_$i"};
      $form->{weight} -= $form->{"weight_$i"} * $form->{"qty_$i"};
      
      # change/add values for assembly item
      map { $form->{"${_}_$i"} = $newform{$_} } qw(partnumber description bin unit weight listprice sellprice inventory_accno income_accno expense_accno);
      
      $form->{sellprice} += $form->{"sellprice_$i"} * $form->{"qty_$i"};
      $form->{weight} += $form->{"weight_$i"} * $form->{"qty_$i"};

    } else {
      # set values for last invoice/order item
      $i = $form->{rowcount};
      $form->{"qty_$i"} = 1 unless ($form->{"qty_$i"});

      map { $form->{"${_}_$i"} = $newform{$_} } qw(partnumber description bin unit listprice inventory_accno income_accno expense_accno sellprice);
      $form->{"sellprice_$i"} = $newform{lastcost} if ($form->{vendor_id});

      if ($form->{exchangerate} != 0) {
	$form->{"sellprice_$i"} /= $form->{exchangerate};
      }
      
      map { $form->{"taxaccounts_$i"} .= "$_ " if ($newform{"IC_tax_$_"}) } split / /, $newform{taxaccounts};
      chop $form->{"taxaccounts_$i"};
    }
    
    $form->{"id_$i"} = $parts_id;
    delete $form->{action};


    # restore original callback
    $callback = $form->{callback};
    $form->{callback} = $form->{old_callback};
    delete $form->{old_callback};
    
    # put callback together
    foreach $key (sort keys %$form) {
      # do single escape for Apache 2.0
      $value = $form->escape($form->{$key}, 1);
      $callback .= qq|&$key=$value|;
    }
    $form->{callback} = $callback;
  }

  # redirect
  $form->isposted($rc);

}



sub delete_part {

  if ($form->{previous_form}) {
    $form->error($locale->text("Cannot delete item which is part of an assembly!"));
  }
  if ($form->{onhand}) {
    $form->error($locale->text("Inventory quantity must be zero!"));
  }
  
  &delete_item;

}


sub delete_service {

  if ($form->{previous_form}) {
    $form->error($locale->text("Cannot delete item which is part of an assembly!"));
  }
  
  &delete_item;
  
}


sub delete_assembly {

  if ($form->{previous_form}) {
    $form->error($locale->text("Cannot delete item which is part of an assembly!"));
  }
  if ($form->{onhand}) {
    $form->error($locale->text("Inventory quantity must be zero!"));
  }
  
  &delete_item;

}


sub delete_item {

  $rc = IC->delete(\%myconfig, \%$form);
  
  if ($rc == 2) {
    $form->error($locale->text("Cannot delete item already invoiced!"));
  }
  
  if ($rc == 3) {
    $form->error($locale->text("Cannot delete item which is part of an assembly!"));
  }
  
  if ($rc == 4) {
    $form->error($locale->text("Cannot delete item on order!"));
  }
 
  # redirect
  $form->isdeleted($rc);

}



sub stock_assembly {

  $form->{title} = $locale->text('Stock Assembly');
  
  $form->header;
  
  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>

<table border=1>
<tr><th class=listtop bgcolor=000000><font color=ffffff>$form->{title}</font></th></tr>

<tr valign=top>
<td>
<table>

<tr>

  <th align=right>|.$locale->text('Number').qq|</th>
  <td><input name=partnumber size=20></td>

</tr>

<tr>

  <th align=right>|.$locale->text('Description').qq|</th>
  <td><input name=description size=35></td>

</tr>

</table>
</td>

</tr>
</table>

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<input type=hidden name=nextsub value=list_assemblies>

<br>
<input class=submit type=submit name=action value="|.$locale->text('Continue').qq|">
</form>

<p>
|.$locale->text('To display all items, leave fields blank')

.qq|

</body>
</html>
|;

}



sub list_assemblies {

  IC->retrieve_assemblies(\%myconfig, \%$form);
  

  $column_header{partnumber} = qq|<th><font color=ffffff>|.$locale->text('Number').qq|</th>|;
  $column_header{description} = qq|<th><font color=ffffff>|.$locale->text('Description').qq|</th>|;
  $column_header{bin} = qq|<th><font color=ffffff>|.$locale->text('Bin').qq|</th>|;
  $column_header{onhand} = qq|<th><font color=ffffff>|.$locale->text('Qty').qq|</th>|;
  $column_header{rop} = qq|<th><font color=ffffff>|.$locale->text('ROP').qq|</th>|;
  $column_header{stock} = qq|<th><font color=ffffff>|.$locale->text('Add').qq|</th>|;

  @column_index = (qw(partnumber description bin onhand rop stock));
  
  $form->{title} = $locale->text('Stock Assembly');

  $form->{callback} = "$form->{script}?action=stock_assembly&path=$form->{path}&login=$form->{login}&password=$form->{password}";
  
  $form->header;
  
  $colspan = $#column_index + 1;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>

<table border=1>
<tr><th class=listtop bgcolor=000000 colspan=$colspan><font color=ffffff>$form->{title}</font></th></tr>

<tr class=listheading bgcolor=336666>|;

  map { print "\n$column_header{$_}" } @column_index;

  print qq|
  </tr>
|;

  $i = 1;
  foreach $ref (@{ $form->{assembly_items} }) {

    map { $ref->{$_} =~ s/"/&quot;/g } qw(partnumber description);
   
    # figure out how many to stock
    $form->{"qty_$i"} = $form->format_amount(\%myconfig, $ref->{rop} - $ref->{onhand});

    $column_data{partnumber} = qq|<td>$ref->{partnumber}</td>|;
    $column_data{description} = qq|<td>$ref->{description}&nbsp;</td>|;
    $column_data{bin} = qq|<td>$ref->{bin}&nbsp;</td>|;
    $column_data{onhand} = qq|<td align=right>|.$form->format_amount(\%myconfig, $ref->{onhand}, -1, "&nbsp;").qq|</td>|;
    $column_data{rop} = qq|<td align=right>|.$form->format_amount(\%myconfig, $ref->{rop}, -1, "&nbsp;").qq|</td>|;
    $column_data{stock} = qq|<td><input name="qty_$i" size=6 value=$form->{"qty_$i"}></td>|;

    $j++; $j %= 2;
    print qq|<tr class=listrow$j><input name="id_$i" type=hidden value=$ref->{id}>\n|;
    
    map { print "\n$column_data{$_}" } @column_index;
    
    print qq|
    </tr>
|;

    $i++;

  }
  
  $i--;
  print qq|
  
</table>
<input name=rowcount type=hidden value="$i">

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

<input name=callback type=hidden value="$form->{callback}">

<input type=hidden name=nextsub value=restock_assemblies>

<br>
<input class=submit type=submit name=action value="|.$locale->text('Continue').qq|">

</form>

</body>
</html>
|;
 
}


sub restock_assemblies {

  IC->restock_assemblies(\%myconfig, \%$form);

  $form->redirect;
  
}


