#=====================================================================
# SQL-Ledger, Accounting
# Copyright (c) 2001
#
#  Author: Dieter Simader
#   Email: dsimader@sql-ledger.org
#     Web: http://www.sql-ledger.org
#
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#======================================================================
#
# Inventory received module
#
#======================================================================


use SL::IR;
use SL::IS;

#$form->{must_select_item}="true";
$form->{show_all_price}="true";
#$form->{pagebreak}="true";

require "$form->{path}/io.pl";

1;
# end of mainF



sub add {
	   #####australia modify

 if(!$form->{page} ||	!$form->{pagerows}){
	 $form->{pagerows}=5;
	$form->{page}=1;
 }
  $form->{title} = $locale->text('Add Vendor Invoice');

  $form->{callback} = "$form->{script}?action=add&path=$form->{path}&login=$form->{login}&password=$form->{password}";

  if($form->{invdate}){
 $lastbatch = $form->{batch};
 $lastdate = $form->{invdate};
 $accno2=$form->{accno2};
 $accno3=$form->{accno3};
 

 }


  &invoice_links;
if($lastdate){
 $form->{invdate}=$lastdate;
$form->{batch}=$lastbatch;
$form->{accno2}=$accno2;
$form->{accno3}=$accno3;
}
  # lock the exchangerate field
  $form->{forex} = 1;
  $form->{"forex_1"} = 1;

  &prepare_invoice;
  
}



sub invoice_links {

  # create links
  $form->create_links("AP", \%myconfig, "vendor",$form->{vcode});

  IR->retrieve_invoice(\%myconfig, \%$form);

  # currencies
  @curr = split /:/, $form->{currencies};
  chomp $curr[0];
  $form->{defaultcurrency} = $curr[0];

  map { $form->{selectcurrency} .= "<option>$_" } @curr;
  
  # vendors
  foreach $ref (@{ $form->{all_vendor} }) {
	  
	  $ref->{name} =~ s/&/&amp;/g;
	  $ref->{name} =~ s/"/&quot;/g;
	  $ref->{name} =~ s/}/\}/g;
	  $ref->{name} =~ s/{/\{/g;
	  
	  
    if ($ref->{id} == $form->{vendor_id}) {
      $form->{vendor} = "$ref->{name}--$ref->{id}";
         $form->{AP1} = "$ref->{vendornumber}--$ref->{name}";
      IR->get_vendor(\%myconfig, \%$form) unless $form->{id};
    }
    $form->{selectvendor} .= "<option>$ref->{name}--$ref->{id}";
#australia
    $form->{"selectAP1"} .= "<option value='$ref->{vendornumber}--$ref->{name}'>$ref->{vendornumber}--$ref->{name}";
  }

  # forex
  $form->{forex} = $form->{exchangerate};
  
  foreach $key (keys %{ $form->{AP_links} }) {

    foreach $ref (@{ $form->{AP_links}{$key} }) {
      $form->{"select$key"} .= "<option value='$ref->{accno}--$ref->{description}'>$ref->{accno}--$ref->{description}";
#australia
      $form->{"chart$key"} .="$ref->{accno}--$ref->{description}";
  }

    if ($key eq "AP_paid") {
      for $i (1 .. scalar @{ $form->{acc_trans}{$key} }) {
	$form->{"AP_paid_$i"} = "$form->{acc_trans}{$key}->[$i-1]->{accno}--$form->{acc_trans}{$key}->[$i-1]->{description}";
	# reverse paid
	$form->{"paid_$i"} = $form->{acc_trans}{$key}->[$i-1]->{amount};
	$form->{"datepaid_$i"} = $form->{acc_trans}{$key}->[$i-1]->{transdate};
	if ($form->{"exchangerate_$i"} = $form->{acc_trans}{$key}->[$i-1]->{exchangerate}) {
	  $form->{"forex_$i"} = 1;
	} else {
	  $form->{"exchangerate_$i"} = 1;
	}
	$form->{"source_$i"} = $form->{acc_trans}{$key}->[$i-1]->{source};
	$form->{paidaccounts} = $i;
      }
    } else {
      $form->{$key} = "$form->{acc_trans}{$key}->[0]->{accno}--$form->{acc_trans}{$key}->[0]->{description}";
    }
  }

  $form->{paidaccounts} = 1 unless (exists $form->{paidaccounts});

  $form->{locked} = ($form->datetonum($form->{invdate}, \%myconfig) <= $form->datetonum($form->{closedto}, \%myconfig));
  
}



sub prepare_invoice {

  $form->{new_form} = !$form->{id} unless (exists $form->{new_form});

  if ($form->{id}) {
        
    map { $form->{$_} =~ s/"/&quot;/g } qw(invnumber ordnumber);

    foreach $ref (@{ $form->{invoice_details} }) {
      $i++;
      map { $form->{"${_}_$i"} = $ref->{$_} } keys %{ $ref };
      
      ($dec) = ($form->{"sellprice_$i"} =~ /\.(\d+)/);
      $dec = length $dec;
      $decimalplaces = ($dec > 2) ? $dec : 2;
      
      $form->{"sellprice_$i"} = $form->format_amount(\%myconfig, $form->{"sellprice_$i"}, $decimalplaces);
      $form->{"qty_$i"} = $form->format_amount(\%myconfig, $form->{"qty_$i"});

      $form->{rowcount} = $i;
    }
  }
#australia
$form->{selectAP}=$form->{selectAP1};

  &display_form;

}



sub form_header {

  $form->{taxincluded} = ($form->{taxincluded}) ? "checked" : "";
#australia
$form->{AP}=$form->{AP1};

  # set option selected
 # $form->dberror($form->{AP1});
# $form->{AP}=$form->{AP1};
  foreach $item (qw(AP vendor currency)) {
$form->{"$item"} =~ s/\(/;brak/g;
$form->{"select$item"} =~ s/\(/;brak/g;

$form->{"$item"} =~ s/\)/;2brak/g;
$form->{"select$item"} =~ s/\)/;2brak/g;

$form->{"$item"} =~ s/\[/;brek/g;
$form->{"select$item"} =~ s/\[/;brek/g;

$form->{"$item"} =~ s/\]/;2brek/g;
$form->{"select$item"} =~ s/\]/;2brek/g;

#australia
$form->{"select$item"} =~ s/ selected//;
    $form->{"select$item"} =~ s/option value='$form->{$item}'>\Q$form->{$item}\E/option selected value='$form->{$item}'>$form->{$item}/;

   $form->{"$item"} =~ s/;brak/\(/g;
$form->{"select$item"} =~ s/;brak/\(/g;

$form->{"$item"} =~ s/;2brak/\)/g;
$form->{"select$item"} =~ s/;2brak/\)/g;

   $form->{"$item"} =~ s/;brek/\[/g;
$form->{"select$item"} =~ s/;brek/\[/g;

$form->{"$item"} =~ s/;2brek/\]/g;
$form->{"select$item"} =~ s/;2brek/\]/g;


  }

  $form->{exchangerate} = $form->format_amount(\%myconfig, $form->{exchangerate});

  $exchangerate = qq|&nbsp;|;
  if ($form->{currency} ne $form->{defaultcurrency}) {
    if ($form->{forex}) {
      $exchangerate = qq|<input type=hidden name=exchangerate value=$form->{exchangerate}>$form->{exchangerate}|;
    } else {
      $exchangerate = qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=exchangerate size=10 value=$form->{exchangerate}>|;
    }
  }
  $exchangerate .= qq|
<input type=hidden name=forex value=$form->{forex}>
|;

  
  $colspan = 7;

  $form->header;
  $form->{title1}="$form->{title} [ Inv No : $form->{invnumber}, Vendor : $form->{AP}, Date : $form->{invdate} ]";

  print qq|
<script>
<!--
function stb(){document.myform.$form->{nextfocus}.focus();parent.document.title ="$form->{title1}";}

function autoComplete (field, select, property, forcematch) {
	var found = false;
	for (var i = 0; i < select.options.length; i++) {
	if (select.options[i][property].toUpperCase().indexOf(field.value.toUpperCase()) == 0) {
		found=true; break;
		}
	}
	if (found) { select.selectedIndex = i; }
	else { select.selectedIndex = -1; }
	if (field.createTextRange) {
		if (forcematch && !found) {
			field.value=field.value.substring(0,field.value.length-1); 
			return;
			}
		var cursorKeys ="8;46;37;38;39;40;33;34;35;36;45;";
		if (cursorKeys.indexOf(event.keyCode+";") == -1) {
			var r1 = field.createTextRange();
			var oldValue = r1.text;
			var newValue = found ? select.options[i][property] : oldValue;
			if (newValue != field.value) {
				field.value = newValue;
				var rNew = field.createTextRange();
				rNew.moveStart('character', oldValue.length) ;
				rNew.select();
				}
			}
		}
	}
	
	
// -->
</script>
<body bgcolor=ffffff  onLoad=stb()>

<form method=post action=$form->{script}  name=myform>

<input type=hidden name=id value=$form->{id}>
<input type=hidden name=orderid value=$form->{orderid}>
<input type=hidden name=new_form value=$form->{new_form}>
<input type=hidden name=title value="$form->{title}">
<input type=hidden name=vcode value="$form->{vcode}">

<input type=hidden name=vendor_id value=$form->{vendor_id}>

<input type=hidden name=closedto value=$form->{closedto}>
<input type=hidden name=locked value=$form->{locked}>
<input type=hidden name=must_select_item value=$form->{must_select_item}>
<input type=hidden name=show_all_price value=$form->{show_all_price}>
<input type=hidden name=pagebreak value=$form->{pagebreak}>
<input type=hidden name=nextfocus value=$form->{nextfocus}>


<table border=0  ><tr><td>

<table border=1 >
<tr class=listtop bgcolor=000000><th>
<font color=ffffff>$form->{title}</font></th></tr>

<tr>
<td>

<table cellspacing=0 cellpadding=0 border=0 width=100%>
<tr >
  <th align=right>|.$locale->text('Trans No.').qq|</th>
  <td nowrap >&nbsp;<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transtype  size=4 value="$form->{transtype}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=batch size=6 value="$form->{batch}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=transno  size=4 value="$form->{transno}"><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=subtransno  size=2 value="$form->{subtransno}"></td>

  <th align=left  nowrap>|.$locale->text('Sub No.').qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=subb  size=4 value="$form->{subb}"></th>
  <th align=left  nowrap>|.$locale->text('Project No.').qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=project  size=4 value="$form->{project}"></th>
</tr>
<tr>
  <td  align=right nowrap>

  <b>|.$locale->text('Currency').qq|</b>
         </td>
  <td  nowrap>

  &nbsp;<select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=currency>$form->{selectcurrency}</select>&nbsp;
         </td>
  <td  align=right  nowrap>

  <b>|.$locale->text('Exchangerate').qq|</b>&nbsp;$exchangerate
  </td>
  <input type=hidden name=selectcurrency value="$form->{selectcurrency}">
  <input type=hidden name=defaultcurrency value=$form->{defaultcurrency}>
  <input type=hidden name=fxgain_accno value=$form->{fxgain_accno}>
  <input type=hidden name=fxloss_accno value=$form->{fxloss_accno}>
</tr>
  
<tr>
  <td  align=right>
  
   <b>|.$locale->text('Vendor').qq|</b>
     </td>
  <td   colspan=3 nowrap><input type=hidden name=keys >

  &nbsp;<select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name=AP  >$form->{selectAP}</select></b>


  </td>
  <input type=hidden name=selectAP value="$form->{selectAP}">
 <input type=hidden name=chartAP value="$form->{chartAP}">
</tr>

<tr>
  <td align=right nowrap>
  
  <b>|.$locale->text('Invoice Number').qq|</b>
       </td>
  <td  nowrap>

  &nbsp;<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=invnumber size=11 value="$form->{invnumber}">&nbsp;
  
        </td>
  <td   align=right nowrap>
 
  <b>|.$locale->text('Order Number').qq|</b>
       </td>
  <td  nowrap>
  
  &nbsp;<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=ordnumber size=11 value="$form->{ordnumber}">
  </td>
</tr>

<tr>
  <td align=right nowrap>
  
  <b>|.$locale->text('D/O Number').qq|</b>
       </td>
  <td  nowrap>

  &nbsp;<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=donumber size=11 value="$form->{donumber}">&nbsp;
  
        </td>
	
	  	   <td align=right>
	    <b>|.$locale->text('Terms').qq|
	   </td>
 <td   nowrap>
  &nbsp;<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=terms size=3 value=$form->{terms}> Days

  </td>
</tr>

<tr>
  <td align=right nowrap>

  <b>|.$locale->text('Invoice Date').qq|
           </td>
  <td  nowrap>

  </b>&nbsp;<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=invdate size=11 value=$form->{invdate} title="($myconfig{dateformat})">&nbsp;
         <link rel="stylesheet" media="screen" href="javascript/dynCalendar.css" />
<script language="javascript" type="text/javascript" src="javascript/browserSniffer.js"></script>
<script language="javascript" type="text/javascript" src="javascript/dynCalendar.js"></script>
 
   <script language="JavaScript" type="text/javascript">
    <!--
        /**
        * Example callback function
        */
        function calendar1Callback(date, month, year)
        {
            document.forms['myform'].invdate.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
        }

        calendar1 = new dynCalendar('calendar1', 'calendar1Callback', 'javascript/images/');
    //-->
    </script>
    
  </td>
  <td align=right  nowrap>

  <b>|.$locale->text('Date Due').qq|
           </td>
  <td  nowrap>

  </b>&nbsp;<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=duedate size=11 value=$form->{duedate} title="($myconfig{dateformat})"> 
  </td>
  
  

  
</tr>

<input type=hidden name=taxpart value="$form->{taxpart}">
<input type=hidden name=taxservice value="$form->{taxservice}">

<input type=hidden name=taxaccounts value="$form->{taxaccounts}">
|;

  foreach $item (split / /, $form->{taxaccounts}) {
    print qq|
<input type=hidden name="${item}_rate" value=$form->{"${item}_rate"}>
<input type=hidden name="${item}_description" value="$form->{"${item}_description"}">
|;
  }

}



sub form_footer {

  $form->{invtotal} = $form->{invsubtotal};
  
  if (($rows = $form->numtextrows($form->{notes}, 50, 8)) < 2) {
    $rows = 2;
  }
  $notes = qq|<textarea name=notes rows=$rows cols=50 wrap=soft>$form->{notes}</textarea>|;

  if (!$form->{taxincluded}) {
    
    foreach $item (split / /, $form->{taxaccounts}) {
      if ($form->{"${item}_base"}) {
	$form->{invtotal} += $form->{"${item}_total"} = $form->round_amount($form->{"${item}_base"} * $form->{"${item}_rate"}, 2);
	$form->{"${item}_total"} = $form->format_amount(\%myconfig, $form->{"${item}_total"}, 2);
	
	$tax .= qq|
	<tr>
	  <th align=right>$form->{"${item}_description"}</th>
	  <td align=right>$form->{"${item}_total"}</td>
	</tr>
	|;
      }
    }

    $form->{invsubtotal} = $form->format_amount(\%myconfig, $form->{invsubtotal}, 2);
    
    $subtotal = qq|
      <tr>
        <th align=right>|.$locale->text('Subtotal').qq|</th>
        <td align=right>$form->{invsubtotal}</td>
      </tr>
      |;

  }


  $form->{invtotal} = $form->format_amount(\%myconfig, $form->{invtotal}, 2);
  $x=$form->{rowcount}-1;
  if(!$form->{"show_all_price"}){
  	$form->{"title2_$x"}="";
  }
  print qq|
<tr>
  <td colspan=$colspan>
    <table>
    <tr>
      <td>
      <table>
        $subtotal

	$tax
	
	<tr>
	  <th align=right>|.$locale->text('Total').qq|</th>
	  <td align=right>$form->{invtotal}</td>
        </tr>
	
      </table>
      </td>|,
      
      qq|<td>
        <table>
	  <tr>
	    <th>|.$locale->text('Notes').qq|</th>
          </tr>
	
	  <tr>
	    <td>$notes<br><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=taxincluded class=checkbox type=checkbox value=1 $form->{taxincluded}>&nbsp;<b>|.$locale->text('Tax Included').qq|</td>
	    	<td>$form->{"title2_$x"}</td>

	  </tr>
	</table>
      </td>

    </tr>

    </table>

  </td>
</tr>
|;


 # @column_index = qw(datepaid paid exchangerate AR_paid source);
if(!$form->{subtype}){
  print qq|

<tr>
  <td colspan=$colspan>
    <table width=100%><tr>
    <th colspan=8 class=listheading bgcolor=336666><font color=ffffff>|.$locale->text('Payments')
    .qq|</font></th>
    </tr>
    |;

    @column_index = qw(datepaid paid exchangerate AP_paid source);
    $column_data{datepaid} = "<th>".$locale->text('Date')."</th>";
    $column_data{paid} = "<th>".$locale->text('Amount')."</th>";
    $column_data{exchangerate} = "<th>".$locale->text('Exch')."</th>";
    $column_data{AP_paid} = "<th>".$locale->text('Account')."</th>";
    $column_data{source} = "<th>".$locale->text('Source')."</th>";

    print "<tr>";
    map { print "$column_data{$_}\n" } @column_index;
    print "</tr>";

    $form->{paidaccounts}++ if ($form->{"paid_$form->{paidaccounts}"});
    for $i (1 .. $form->{paidaccounts}) {

      print "<tr>\n";

      $form->{"selectAP_paid_$i"} = $form->{selectAP_paid};
      $form->{"selectAP_paid_$i"} =~ s/option value='$form->{"AP_paid_$i"}'>\Q$form->{"AP_paid_$i"}\E/option selected  value='$form->{"AP_paid_$i"}'>$form->{"AP_paid_$i"}/;

      # format amounts
      $form->{"paid_$i"} = $form->format_amount(\%myconfig, $form->{"paid_$i"}, 2);
      $form->{"exchangerate_$i"} = $form->format_amount(\%myconfig, $form->{"exchangerate_$i"});

      $exchangerate = qq|&nbsp;|;
      if ($form->{currency} ne $form->{defaultcurrency}) {
	if ($form->{"forex_$i"}) {
	  $exchangerate = qq|<input type=hidden name="exchangerate_$i" value=$form->{"exchangerate_$i"}>$form->{"exchangerate_$i"}|;
	} else {
	  $exchangerate = qq|<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="exchangerate_$i" size=10 value=$form->{"exchangerate_$i"}>|;
	}
      }
      $exchangerate .= qq|
<input type=hidden name="forex_$i" value=$form->{"forex_$i"}>
|;

      $column_data{"paid_$i"} = qq|<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="paid_$i" size=10 value=$form->{"paid_$i"}></td>|;
      $column_data{"exchangerate_$i"} = qq|<td>$exchangerate</td>|;
      $column_data{"AP_paid_$i"} = qq|<td><select  onkeypress="selectKeyPress();" onkeydown="setsubmit(this);selectKeyDown();" onblur="clr();" onfocus="clr();"  name="AP_paid_$i">$form->{"selectAP_paid_$i"}</select></td>|;
      $column_data{"datepaid_$i"} = qq|<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="datepaid_$i" size=11 title=$myconfig{dateformat} value=$form->{"datepaid_$i"}>

				   <script language="JavaScript" type="text/javascript">
				    <!--
					/**
					* Example callback function
					*/
					function calendar2Callback(date, month, year)
					{
					    document.forms['myform'].datepaid_$i.value = formatDate(new Date(getDateFromFormat(year + '-' + month + '-' + date,'yyyy-M-d')),'$myconfig{dateformat}');
					}
				
					calendar2 = new dynCalendar('calendar2', 'calendar2Callback', 'javascript/images/');
				    //-->
				    </script>
				    </td>|;
      $column_data{"source_$i"} = qq|<td><input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name="source_$i" size=10 value="$form->{"source_$i"}"></td>|;

      map { print qq|$column_data{"${_}_$i"}\n| } @column_index;

      print "</tr>\n";
    }
}
    print qq|
      <input type=hidden name=paidaccounts value=$form->{paidaccounts}>
    <input type=hidden name=subtype value=$form->{subtype}>
    <input type=hidden name=AP_paid value=$form->{AP_paid}>
     <input type=hidden name=source value="$form->{source}">
      <input type=hidden name=selectAP_paid value="$form->{selectAP_paid}">

      </table>
    </td>
  </tr>

</table>
</td>
</tr>

</table>

<br>			  <input type=hidden name=action value=update_form2>

|;
   #####australia modify   

  $invdate = $form->datetonum($form->{invdate}, \%myconfig);
  $closedto = $form->datetonum($form->{closedto}, \%myconfig);
    if(!$form->{readonly}){
  if ($form->{id}) {
    print qq|
    <input class=submit type=submit name=action value="|.$locale->text('Update Form').qq|">
|;
    if($form->{pagebreak}){

   #####australia modify
  		print qq|<br>|;
		for $j (1 ..(( $i/$form->{pagerows})+1) ) {
			  print qq|
			  <input class=submit type=submit name=page value=' $j '>	  
			  |;
		  }
  		print qq|<br>|;
    }


    if (!$form->{revtrans}) {
      if (!$form->{locked}) {
	print qq|
	<input class=submit type=submit name=action value="|.$locale->text('Post Invoice').qq|">
	<input class=submit type=submit name=action value="|.$locale->text('Delete Invoice').qq|">
|;
      }
    }

    if ($invdate > $closedto) {
      print qq|
      <input class=submit type=submit name=action value="|.$locale->text('Post As New Invoice').qq|">
      <input class=submit type=submit name=action value="|.$locale->text('Create Order').qq|">
|;
    }

  } else {
    if ($invdate > $closedto) {
      print qq|
      <input class=submit type=submit name=action value="|.$locale->text('Update Form').qq|">
    |;
   if($form->{pagebreak}){
   #####australia modify
  		print qq|<br>|;
		for $j (1 ..(( $i/$form->{pagerows})+1) ) {
			  print qq|
			  <input class=submit type=submit name=page value=' $j '>	  
			  |;
		  }
  		print qq|<br>|;
   }
  print qq|
     <input class=submit type=submit name=action value="|.$locale->text('Post Invoice').qq|">|;
    }
  }
}
print qq|

</td>
</tr>

</table>

<input type=hidden name=rowcount value=$form->{rowcount}>

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=callback type=hidden value="$form->{callback}">

<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

</form>
|

.$locale->text('Enter a number or description and click on "Update Form"')
.qq|<br>|
.$locale->text('To remove any items delete the number and click on "Update Form"')

.qq|

</body>
</html>
|;

}


   #####australia modify
sub update_form {
   #####australia modify
  $form->{page}=$form->{focus}/$form->{pagerows};

 ($form->{page},$dec) = split(/\./,$form->{page});
if($dec >=0){
	  $form->{page}++;	  
  }

  
&update_form2;
}


   #####australia modify
sub update_form2 {
 #the following statement must be coresspondent to the io.pl sub form_row();
  #this statment will reorder the sequence of rows
    $form->{AP1}=$form->{AP};

  ( $form->{AP},$null ) = split /--/, $form->{AP};
 for $j(1..$form->{rowcount}){
	  if($form->{"sr_$j"} ne $form->{"sr2_$j"}){
	  for ($i=$form->{"sr2_$j"};$i > $form->{"sr_$j"};--$i){
	       @column_index = qw(partnumber description onhand qty unit   sellprice  lastcost discount bin part_ordnumber last_parts_qty ord_parts qty po_details partnotes id inventory_Accno bin	      income_accno expense_accno listprice assembly taxaccounts parts_id linetotal po delivery_date  remark2);

	          map { $form->{$_."t"} =  $form->{$_."_$form->{\"sr2_$i\"}"} } @column_index;

		  $k=$i-1;
		  map { $form->{$_."_$form->{\"sr2_$i\"}"} =  $form->{$_."_$form->{\"sr2_$k\"}"} } @column_index;

		  map { $form->{$_."_$form->{\"sr2_$k\"}"} =  $form->{$_."t"} } @column_index;

		 
	  }
	  }
	  
	
  
 }
  ###end of statement of reorder
  # if the vendor changed get new values
 # ($null, $vendor_id) = split /--/, $form->{vendor};
 # if ($form->{vendor_id} ne $vendor_id) {
    # delete tax accounts
       IR->get_vendorid(\%myconfig, \%$form);

        map { delete $form->{"${_}_rate"} } (split / /, $form->{taxaccounts});

  #  $form->{vendor_id} = $vendor_id;
	  $taxincluded=$form->{taxincluded};
    IR->get_vendor(\%myconfig, \%$form);
    	  $form->{taxincluded}=$taxincluded;
  #}
  
  $form->{exchangerate} = $exchangerate if ($form->{forex} = ($exchangerate = $form->check_exchangerate(\%myconfig, $form->{currency}, $form->{invdate}, 'sell')));
  
  $form->{exchangerate} = $form->parse_amount(\%myconfig, $form->{exchangerate});
  
  for $i (1 .. $form->{paidaccounts}) {
    if ($form->{"paid_$i"}) {
      map { $form->{"${_}_$i"} = $form->parse_amount(\%myconfig, $form->{"${_}_$i"}) } qw(paid exchangerate);

      $form->{"exchangerate_$i"} = $exchangerate if ($form->{"forex_$i"} = ($exchangerate = $form->check_exchangerate(\%myconfig, $form->{currency}, $form->{"datepaid_$i"}, 'sell')));
    }
  }
  
  $i = $form->{rowcount};
   #####australia modify
  $form->{focus}=$form->{rowcount};
#	$form->{"nextfocus"}  = "partnumber_$i";

  if (($form->{"partnumber_$i"} eq "") && ($form->{"description_$i"} eq "")) {

    &check_form;
    
  } else {
   $form->{"partnumber_$i"} =~ s/'/\\'/g;
$form->{"description_$i"} =~ s/'/\\'/g;

    IR->retrieve_item(\%myconfig, \%$form);

    my $rows = scalar @{ $form->{item_list} };

    if ($rows) {
      $form->{"qty_$i"}                     = 1 unless ($form->{"qty_$i"});
      
      if ($rows > 1|| $form->{must_select_item}) {
	
	&select_item;
	exit;
	
      } else {
	map { $form->{item_list}[$i]{$_} =~ s/"/&quot;/g } qw(partnumber description unit);
	map { $form->{"${_}_$i"} = $form->{item_list}[0]{$_} } keys %{ $form->{item_list}[0] };

	($dec) = ($form->{"sellprice_$i"} =~ /\.(\d+)/);
	$dec = length $dec;
	$decimalplaces = ($dec > 2) ? $dec : 2;
	
        # if there is an exchange rate adjust sellprice
        if (($form->{exchangerate} * 1) != 0) {
	  $form->{"sellprice_$i"} /= $form->{exchangerate};
	}
	
	$form->{"sellprice_$i"} = $form->format_amount(\%myconfig, $form->{"sellprice_$i"}, $decimalplaces);
	$form->{"qty_$i"} =  $form->format_amount(\%myconfig, $form->{"qty_$i"});
      }

      &display_form;

    } else {
      # ok, so this is a new part
      # ask if it is a part or service item

      $form->{"id_$i"}		= 0;
      $form->{"unit_$i"}	= $locale->text('ea');

      &new_item;
      
    }
  }
}



sub post_invoice {

  $form->isblank("invnumber", $locale->text('Invoice Number missing!'));
  $form->isblank("invdate", $locale->text('Invoice Date missing!'));
  
  &validate_items;

   ($form->{AP}) = split /--/, $form->{AP};
  
  IR->get_vendorid(\%myconfig, \%$form);
  
  
  # if the vendor changed get new values
  #($null, $vendor_id) = split /--/, $form->{vendor};
  #if ($form->{vendor_id} ne $vendor_id) {
  #  $form->{vendor_id} = $vendor_id;
    IR->get_vendor(\%myconfig, \%$form);
  #}
 
  $closedto = $form->datetonum($form->{closedto}, \%myconfig);
  $invdate = $form->datetonum($form->{invdate}, \%myconfig);

  $form->error($locale->text('Cannot post invoice for a closed period!')) if ($invdate <= $closedto);

  $form->isblank("exchangerate", $locale->text('Exchangerate missing!')) if ($form->{currency} ne $form->{defaultcurrency});
  
  for $i (1 .. $form->{paidaccounts}) {
    if ($form->{"paid_$i"}) {
      $datepaid = $form->datetonum($form->{"datepaid_$i"}, \%myconfig);

      $form->isblank("datepaid_$i", $locale->text('Payment date missing!'));
      
      $form->error($locale->text('Cannot post payment for a closed period!')) if ($datepaid <= $closedto);
      
      if ($form->{currency} ne $form->{defaultcurrency}) {
	$form->{"exchangerate_$i"} = $form->{exchangerate} if ($invdate == $datepaid);
	$form->isblank("exchangerate_$i", $locale->text('Exchangerate for payment missing!'));
      }
    }
  }
  
  
  ($form->{AP}) = split /--/, $form->{AP};
  ($form->{AP_paid}) = split /--/, $form->{AP_paid};
  


  if (IR->post_invoice(\%myconfig, \%$form)) {
    if ($form->{orderid}) {
    
      $form->{script} = "oe.pl";
      &keeporder;
	
    } else {
    
      if ($form->{new_form}) {
      
	$form->header;
	
	print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>
|;

	print qq|
<h2><font color=blue>|.$locale->text('Confirm!').qq|</font></h2>

<h4>|.$locale->text('Do you want to create another Invoice?').qq|</h4>
<p>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=action class=submit type=submit value="|.$locale->text('Yes').qq|">
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=action class=submit type=submit value="|.$locale->text('No').qq|">

<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=callback type=hidden value="$form->{callback}&nextfocus=transtype&vcode=$form->{vcode}">


<input type=hidden name=path value=$form->{path}>
<input type=hidden name=login value=$form->{login}>
<input type=hidden name=password value=$form->{password}>

</form>
|;

      } else {
	 #    $form->{callback}= $form->unescape($form->{callback});
	$form->isposted(1);
      }
    }
  }

}



sub edit {
   #####australia modify
 if(!$form->{page} ||	!$form->{pagerows}){
	 $form->{pagerows}=5;
	$form->{page}=1;
 }
  $form->{title} = $locale->text('Edit Vendor Invoice');

  &invoice_links;
  #   $form->{"accno1_2"}=$form->{AP};

  &prepare_invoice;
  
}


sub delete_invoice {

  $form->header;

  print qq|
<body bgcolor=ffffff>

<form method=post action=$form->{script}>
|;

  # delete action variable
  delete $form->{action};

  foreach $key (keys %$form) {
    $form->{$key} =~ s/"/&quot;/g;
    print qq|<input type=hidden name=$key value="$form->{$key}">\n|;
  }

  print qq|
<h2><font color=blue>|.$locale->text('Confirm!').qq|</font></h2>

<h4>|.$locale->text('Are you sure you want to delete Invoice Number').qq| $form->{invnumber}</h4>
<p>
<input onkeydown='setnextfocus(this)' onfocus='setfocus(this);' name=action class=submit type=submit value="|.$locale->text('Yes Delete Invoice').qq|">
</form>
|;


}



sub yes_delete_invoice {

  $form->isdeleted(IR->delete_invoice(\%myconfig, \%$form));

}


